/* Document.c generated by valac 0.48.9, the Vala compiler
 * generated from Document.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/

#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gstdio.h>
#include <glib/gi18n-lib.h>
#include <libxml/tree.h>
#include <libxml/parser.h>

#define TYPE_DOCUMENT (document_get_type ())
#define DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DOCUMENT, Document))
#define DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DOCUMENT, DocumentClass))
#define IS_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DOCUMENT))
#define IS_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DOCUMENT))
#define DOCUMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DOCUMENT, DocumentClass))

typedef struct _Document Document;
typedef struct _DocumentClass DocumentClass;
typedef struct _DocumentPrivate DocumentPrivate;

#define TYPE_DRAW_AREA (draw_area_get_type ())
#define DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DRAW_AREA, DrawArea))
#define DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DRAW_AREA, DrawAreaClass))
#define IS_DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DRAW_AREA))
#define IS_DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DRAW_AREA))
#define DRAW_AREA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DRAW_AREA, DrawAreaClass))

typedef struct _DrawArea DrawArea;
typedef struct _DrawAreaClass DrawAreaClass;

#define TYPE_IMAGE_MANAGER (image_manager_get_type ())
#define IMAGE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_IMAGE_MANAGER, ImageManager))
#define IMAGE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_IMAGE_MANAGER, ImageManagerClass))
#define IS_IMAGE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_IMAGE_MANAGER))
#define IS_IMAGE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_IMAGE_MANAGER))
#define IMAGE_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_IMAGE_MANAGER, ImageManagerClass))

typedef struct _ImageManager ImageManager;
typedef struct _ImageManagerClass ImageManagerClass;
enum  {
	DOCUMENT_0_PROPERTY,
	DOCUMENT_FILENAME_PROPERTY,
	DOCUMENT_LABEL_PROPERTY,
	DOCUMENT_SAVE_NEEDED_PROPERTY,
	DOCUMENT_NUM_PROPERTIES
};
static GParamSpec* document_properties[DOCUMENT_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _image_manager_unref0(var) ((var == NULL) ? NULL : (var = (image_manager_unref (var), NULL)))

struct _Document {
	GObject parent_instance;
	DocumentPrivate * priv;
};

struct _DocumentClass {
	GObjectClass parent_class;
};

struct _DocumentPrivate {
	DrawArea* _da;
	gchar* _filename;
	gboolean _from_user;
	ImageManager* _image_manager;
	gboolean _save_needed;
};

static gint Document_private_offset;
static gpointer document_parent_class = NULL;
extern gchar* minder_version;

GType document_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Document, g_object_unref)
GType draw_area_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DrawArea, g_object_unref)
gpointer image_manager_ref (gpointer instance);
void image_manager_unref (gpointer instance);
GParamSpec* param_spec_image_manager (const gchar* name,
                                      const gchar* nick,
                                      const gchar* blurb,
                                      GType object_type,
                                      GParamFlags flags);
void value_set_image_manager (GValue* value,
                              gpointer v_object);
void value_take_image_manager (GValue* value,
                               gpointer v_object);
gpointer value_get_image_manager (const GValue* value);
GType image_manager_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ImageManager, image_manager_unref)
Document* document_new (DrawArea* da);
Document* document_construct (GType object_type,
                              DrawArea* da);
ImageManager* image_manager_new (void);
ImageManager* image_manager_construct (GType object_type);
static void document_canvas_changed (Document* self);
static void _document_canvas_changed_draw_area_changed (DrawArea* _sender,
                                                 gpointer self);
static void document_set_save_needed (Document* self,
                               gboolean value);
void document_auto_save (Document* self);
void document_load_filename (Document* self,
                             const gchar* fname,
                             gboolean saved);
void document_set_filename (Document* self,
                            const gchar* value);
gboolean document_is_saved (Document* self);
gboolean document_load (Document* self);
const gchar* document_get_filename (Document* self);
void draw_area_load (DrawArea* self,
                     xmlNode* n);
gboolean document_save (Document* self);
gboolean draw_area_save (DrawArea* self,
                         xmlNode* parent);
gboolean document_remove (Document* self);
gboolean document_get_save_needed (Document* self);
gchar* document_get_label (Document* self);
static void document_finalize (GObject * obj);
static GType document_get_type_once (void);
static void _vala_document_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec);
static void _vala_document_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec);

static inline gpointer
document_get_instance_private (Document* self)
{
	return G_STRUCT_MEMBER_P (self, Document_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_document_canvas_changed_draw_area_changed (DrawArea* _sender,
                                            gpointer self)
{
	document_canvas_changed ((Document*) self);
}

Document*
document_construct (GType object_type,
                    DrawArea* da)
{
	Document * self = NULL;
	DrawArea* _tmp0_;
	gchar* dir = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	ImageManager* _tmp13_;
	DrawArea* _tmp14_;
	g_return_val_if_fail (da != NULL, NULL);
	self = (Document*) g_object_new (object_type, NULL);
	_tmp0_ = _g_object_ref0 (da);
	_g_object_unref0 (self->priv->_da);
	self->priv->_da = _tmp0_;
	_tmp1_ = g_get_user_data_dir ();
	_tmp2_ = g_build_filename (_tmp1_, "minder", NULL);
	dir = _tmp2_;
	_tmp3_ = dir;
	if (g_mkdir_with_parents (_tmp3_, 0775) == 0) {
		gint i = 0;
		i = 1;
		{
			gboolean _tmp4_ = FALSE;
			_tmp4_ = TRUE;
			while (TRUE) {
				const gchar* _tmp6_;
				gint _tmp7_;
				gchar* _tmp8_;
				gchar* _tmp9_;
				gchar* _tmp10_;
				gchar* _tmp11_;
				gchar* _tmp12_;
				if (!_tmp4_) {
					const gchar* _tmp5_;
					_tmp5_ = self->priv->_filename;
					if (!g_file_test (_tmp5_, G_FILE_TEST_EXISTS)) {
						break;
					}
				}
				_tmp4_ = FALSE;
				_tmp6_ = dir;
				_tmp7_ = i;
				i = _tmp7_ + 1;
				_tmp8_ = g_strdup_printf ("%d.minder", _tmp7_);
				_tmp9_ = _tmp8_;
				_tmp10_ = g_strconcat (_ ("unnamed"), _tmp9_, NULL);
				_tmp11_ = _tmp10_;
				_tmp12_ = g_build_filename (_tmp6_, _tmp11_, NULL);
				_g_free0 (self->priv->_filename);
				self->priv->_filename = _tmp12_;
				_g_free0 (_tmp11_);
				_g_free0 (_tmp9_);
			}
		}
		self->priv->_from_user = FALSE;
	}
	_tmp13_ = image_manager_new ();
	_image_manager_unref0 (self->priv->_image_manager);
	self->priv->_image_manager = _tmp13_;
	_tmp14_ = self->priv->_da;
	g_signal_connect_object (_tmp14_, "changed", (GCallback) _document_canvas_changed_draw_area_changed, self, 0);
	_g_free0 (dir);
	return self;
}

Document*
document_new (DrawArea* da)
{
	return document_construct (TYPE_DOCUMENT, da);
}

static void
document_canvas_changed (Document* self)
{
	g_return_if_fail (self != NULL);
	document_set_save_needed (self, TRUE);
	document_auto_save (self);
}

void
document_load_filename (Document* self,
                        const gchar* fname,
                        gboolean saved)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (fname != NULL);
	document_set_filename (self, fname);
	self->priv->_from_user = saved;
}

gboolean
document_is_saved (Document* self)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_from_user;
	return result;
}

gboolean
document_load (Document* self)
{
	xmlDoc* doc = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	xmlDoc* _tmp2_;
	xmlDoc* _tmp3_;
	DrawArea* _tmp4_;
	xmlDoc* _tmp5_;
	xmlNode* _tmp6_;
	xmlDoc* _tmp7_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = document_get_filename (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = xmlReadFile (_tmp1_, NULL, (gint) XML_PARSE_HUGE);
	doc = _tmp2_;
	_tmp3_ = doc;
	if (_tmp3_ == NULL) {
		result = FALSE;
		return result;
	}
	_tmp4_ = self->priv->_da;
	_tmp5_ = doc;
	_tmp6_ = xmlDocGetRootElement (_tmp5_);
	draw_area_load (_tmp4_, _tmp6_);
	_tmp7_ = doc;
	xmlFreeDoc (_tmp7_);
	result = TRUE;
	return result;
}

gboolean
document_save (Document* self)
{
	xmlDoc* doc = NULL;
	xmlDoc* _tmp0_;
	xmlNode* root = NULL;
	xmlNode* _tmp1_;
	const gchar* _tmp2_;
	DrawArea* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = xmlNewDoc ((xmlChar*) "1.0");
	doc = _tmp0_;
	_tmp1_ = xmlNewNode (NULL, (xmlChar*) "minder");
	root = _tmp1_;
	_tmp2_ = minder_version;
	xmlSetProp (root, (xmlChar*) "version", (xmlChar*) _tmp2_);
	xmlDocSetRootElement (doc, root);
	_tmp3_ = self->priv->_da;
	draw_area_save (_tmp3_, root);
	_tmp4_ = document_get_filename (self);
	_tmp5_ = _tmp4_;
	xmlSaveFormatFile (_tmp5_, doc, 1);
	xmlFreeDoc (doc);
	document_set_save_needed (self, FALSE);
	result = TRUE;
	return result;
}

gboolean
document_remove (Document* self)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	if (!self->priv->_from_user) {
		const gchar* _tmp0_;
		_tmp0_ = self->priv->_filename;
		g_unlink (_tmp0_);
	}
	result = TRUE;
	return result;
}

void
document_auto_save (Document* self)
{
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_save_needed;
	if (_tmp0_) {
		document_save (self);
	}
}

const gchar*
document_get_filename (Document* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_filename;
	result = _tmp0_;
	return result;
}

void
document_set_filename (Document* self,
                       const gchar* value)
{
	const gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_filename;
	if (g_strcmp0 (_tmp0_, value) != 0) {
		gchar* _tmp2_;
		if (!self->priv->_from_user) {
			const gchar* _tmp1_;
			_tmp1_ = self->priv->_filename;
			g_unlink (_tmp1_);
		}
		_tmp2_ = g_strdup (value);
		_g_free0 (self->priv->_filename);
		self->priv->_filename = _tmp2_;
		self->priv->_from_user = TRUE;
	}
	g_object_notify_by_pspec ((GObject *) self, document_properties[DOCUMENT_FILENAME_PROPERTY]);
}

gchar*
document_get_label (Document* self)
{
	gchar* result;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_filename;
	_tmp1_ = g_path_get_basename (_tmp0_);
	result = _tmp1_;
	return result;
}

gboolean
document_get_save_needed (Document* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_save_needed;
	return result;
}

static void
document_set_save_needed (Document* self,
                          gboolean value)
{
	g_return_if_fail (self != NULL);
	if (document_get_save_needed (self) != value) {
		self->priv->_save_needed = value;
		g_object_notify_by_pspec ((GObject *) self, document_properties[DOCUMENT_SAVE_NEEDED_PROPERTY]);
	}
}

static void
document_class_init (DocumentClass * klass,
                     gpointer klass_data)
{
	document_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &Document_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_document_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_document_set_property;
	G_OBJECT_CLASS (klass)->finalize = document_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DOCUMENT_FILENAME_PROPERTY, document_properties[DOCUMENT_FILENAME_PROPERTY] = g_param_spec_string ("filename", "filename", "filename", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DOCUMENT_LABEL_PROPERTY, document_properties[DOCUMENT_LABEL_PROPERTY] = g_param_spec_string ("label", "label", "label", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DOCUMENT_SAVE_NEEDED_PROPERTY, document_properties[DOCUMENT_SAVE_NEEDED_PROPERTY] = g_param_spec_boolean ("save-needed", "save-needed", "save-needed", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}

static void
document_instance_init (Document * self,
                        gpointer klass)
{
	self->priv = document_get_instance_private (self);
	self->priv->_save_needed = FALSE;
}

static void
document_finalize (GObject * obj)
{
	Document * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DOCUMENT, Document);
	_g_object_unref0 (self->priv->_da);
	_g_free0 (self->priv->_filename);
	_image_manager_unref0 (self->priv->_image_manager);
	G_OBJECT_CLASS (document_parent_class)->finalize (obj);
}

static GType
document_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DocumentClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) document_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Document), 0, (GInstanceInitFunc) document_instance_init, NULL };
	GType document_type_id;
	document_type_id = g_type_register_static (G_TYPE_OBJECT, "Document", &g_define_type_info, 0);
	Document_private_offset = g_type_add_instance_private (document_type_id, sizeof (DocumentPrivate));
	return document_type_id;
}

GType
document_get_type (void)
{
	static volatile gsize document_type_id__volatile = 0;
	if (g_once_init_enter (&document_type_id__volatile)) {
		GType document_type_id;
		document_type_id = document_get_type_once ();
		g_once_init_leave (&document_type_id__volatile, document_type_id);
	}
	return document_type_id__volatile;
}

static void
_vala_document_get_property (GObject * object,
                             guint property_id,
                             GValue * value,
                             GParamSpec * pspec)
{
	Document * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DOCUMENT, Document);
	switch (property_id) {
		case DOCUMENT_FILENAME_PROPERTY:
		g_value_set_string (value, document_get_filename (self));
		break;
		case DOCUMENT_LABEL_PROPERTY:
		g_value_take_string (value, document_get_label (self));
		break;
		case DOCUMENT_SAVE_NEEDED_PROPERTY:
		g_value_set_boolean (value, document_get_save_needed (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_document_set_property (GObject * object,
                             guint property_id,
                             const GValue * value,
                             GParamSpec * pspec)
{
	Document * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DOCUMENT, Document);
	switch (property_id) {
		case DOCUMENT_FILENAME_PROPERTY:
		document_set_filename (self, g_value_get_string (value));
		break;
		case DOCUMENT_SAVE_NEEDED_PROPERTY:
		document_set_save_needed (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

