/* Layout.c generated by valac 0.48.9, the Vala compiler
 * generated from Layout.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/

#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>

#define TYPE_LAYOUT (layout_get_type ())
#define LAYOUT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LAYOUT, Layout))
#define LAYOUT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LAYOUT, LayoutClass))
#define IS_LAYOUT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LAYOUT))
#define IS_LAYOUT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LAYOUT))
#define LAYOUT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LAYOUT, LayoutClass))

typedef struct _Layout Layout;
typedef struct _LayoutClass LayoutClass;
typedef struct _LayoutPrivate LayoutPrivate;
typedef enum  {
	NODE_SIDE_LEFT = 1,
	NODE_SIDE_TOP = 2,
	NODE_SIDE_RIGHT = 4,
	NODE_SIDE_BOTTOM = 8
} NodeSide;

#define TYPE_NODE_SIDE (node_side_get_type ())

#define TYPE_NODE (node_get_type ())
#define NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NODE, Node))
#define NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NODE, NodeClass))
#define IS_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NODE))
#define IS_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NODE))
#define NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NODE, NodeClass))

typedef struct _Node Node;
typedef struct _NodeClass NodeClass;

#define TYPE_NODE_BOUNDS (node_bounds_get_type ())
typedef struct _NodeBounds NodeBounds;
enum  {
	LAYOUT_0_PROPERTY,
	LAYOUT_NAME_PROPERTY,
	LAYOUT_ICON_PROPERTY,
	LAYOUT_BALANCEABLE_PROPERTY,
	LAYOUT_NUM_PROPERTIES
};
static GParamSpec* layout_properties[LAYOUT_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block18Data Block18Data;
#define _g_array_unref0(var) ((var == NULL) ? NULL : (var = (g_array_unref (var), NULL)))

#define TYPE_DRAW_AREA (draw_area_get_type ())
#define DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DRAW_AREA, DrawArea))
#define DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DRAW_AREA, DrawAreaClass))
#define IS_DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DRAW_AREA))
#define IS_DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DRAW_AREA))
#define DRAW_AREA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DRAW_AREA, DrawAreaClass))

typedef struct _DrawArea DrawArea;
typedef struct _DrawAreaClass DrawAreaClass;

#define TYPE_STYLE (style_get_type ())
#define STYLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STYLE, Style))
#define STYLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STYLE, StyleClass))
#define IS_STYLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STYLE))
#define IS_STYLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STYLE))
#define STYLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STYLE, StyleClass))

typedef struct _Style Style;
typedef struct _StyleClass StyleClass;

struct _NodeBounds {
	gdouble x;
	gdouble y;
	gdouble width;
	gdouble height;
};

struct _Layout {
	GObject parent_instance;
	LayoutPrivate * priv;
	gdouble _rt_gap;
};

struct _LayoutClass {
	GObjectClass parent_class;
	NodeSide (*side_mapping) (Layout* self, NodeSide side);
	void (*initialize) (Layout* self, Node* parent);
	void (*bbox) (Layout* self, Node* parent, gint side_mask, NodeBounds* result);
	void (*adjust_tree) (Layout* self, Node* parent, gint child_index, gint side_mask, gdouble amount);
	void (*adjust_tree_all) (Layout* self, Node* n, NodeBounds* prev, gdouble amount, const gchar* msg);
	void (*propagate_side) (Layout* self, Node* parent, NodeSide side);
	NodeSide (*get_side) (Layout* self, Node* n);
	void (*set_side) (Layout* self, Node* current);
	void (*handle_update_by_edit) (Layout* self, Node* n, gdouble diffw, gdouble diffh);
	void (*handle_update_by_fold) (Layout* self, Node* n);
	gdouble (*get_insert_adjust) (Layout* self, Node* child);
	void (*handle_update_by_insert) (Layout* self, Node* parent, Node* child, gint pos);
	void (*handle_update_by_delete) (Layout* self, Node* parent, gint index, NodeSide side, gdouble size);
	void (*position_root) (Layout* self, Node* last, Node* n);
};

struct _LayoutPrivate {
	gchar* _name;
	gchar* _icon;
	gboolean _balanceable;
};

struct _Block18Data {
	int _ref_count_;
	Layout* self;
	Node* parent;
};

static gint Layout_private_offset;
static gpointer layout_parent_class = NULL;

GType layout_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Layout, g_object_unref)
GType node_side_get_type (void) G_GNUC_CONST;
GType node_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Node, g_object_unref)
GType node_bounds_get_type (void) G_GNUC_CONST;
NodeBounds* node_bounds_dup (const NodeBounds* self);
void node_bounds_free (NodeBounds* self);
NodeSide layout_side_mapping (Layout* self,
                              NodeSide side);
void layout_initialize (Layout* self,
                        Node* parent);
void layout_bbox (Layout* self,
                  Node* parent,
                  gint side_mask,
                  NodeBounds* result);
void layout_adjust_tree (Layout* self,
                         Node* parent,
                         gint child_index,
                         gint side_mask,
                         gdouble amount);
void layout_adjust_tree_all (Layout* self,
                             Node* n,
                             NodeBounds* prev,
                             gdouble amount,
                             const gchar* msg);
void layout_propagate_side (Layout* self,
                            Node* parent,
                            NodeSide side);
NodeSide layout_get_side (Layout* self,
                          Node* n);
void layout_set_side (Layout* self,
                      Node* current);
void layout_handle_update_by_edit (Layout* self,
                                   Node* n,
                                   gdouble diffw,
                                   gdouble diffh);
void layout_handle_update_by_fold (Layout* self,
                                   Node* n);
gdouble layout_get_insert_adjust (Layout* self,
                                  Node* child);
void layout_handle_update_by_insert (Layout* self,
                                     Node* parent,
                                     Node* child,
                                     gint pos);
void layout_handle_update_by_delete (Layout* self,
                                     Node* parent,
                                     gint index,
                                     NodeSide side,
                                     gdouble size);
void layout_position_root (Layout* self,
                           Node* last,
                           Node* n);
Layout* layout_new (void);
Layout* layout_construct (GType object_type);
static NodeSide layout_real_side_mapping (Layout* self,
                                   NodeSide side);
static void layout_real_initialize (Layout* self,
                             Node* parent);
static Block18Data* block18_data_ref (Block18Data* _data18_);
static void block18_data_unref (void * _userdata_);
GArray* node_children (Node* self);
NodeSide node_get_side (Node* self);
void node_set_side (Node* self,
                    NodeSide value);
static void __lambda35_ (Layout* self,
                  Node* item);
void node_detach (Node* self,
                  NodeSide side);
static void ___lambda35__gfunc (gconstpointer data,
                         gpointer self);
static void __lambda52_ (Block18Data* _data18_,
                  Node* item);
void node_attach_init (Node* self,
                       Node* parent,
                       gint index);
static void ___lambda52__gfunc (gconstpointer data,
                         gpointer self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_slist_free__g_object_unref0_ (GSList* self);
static void layout_real_bbox (Layout* self,
                       Node* parent,
                       gint side_mask,
                       NodeBounds* result);
void node_bbox (Node* self,
                gdouble* x,
                gdouble* y,
                gdouble* w,
                gdouble* h);
gboolean node_get_folded (Node* self);
void node_get_tree_bbox (Node* self,
                         NodeBounds * result);
void layout_update_tree_size (Layout* self,
                              Node* n);
void node_set_tree_bbox (Node* self,
                         NodeBounds * value);
gint node_side_horizontal (void);
void node_set_tree_size (Node* self,
                         gdouble value);
gdouble layout_get_adjust (Layout* self,
                           Node* parent);
gdouble node_get_tree_size (Node* self);
static void layout_real_adjust_tree (Layout* self,
                              Node* parent,
                              gint child_index,
                              gint side_mask,
                              gdouble amount);
gdouble node_get_posy (Node* self);
void node_set_posy (Node* self,
                    gdouble value);
gdouble node_get_posx (Node* self);
void node_set_posx (Node* self,
                    gdouble value);
static void layout_real_adjust_tree_all (Layout* self,
                                  Node* n,
                                  NodeBounds* prev,
                                  gdouble amount,
                                  const gchar* msg);
Node* node_get_parent (Node* self);
gint node_index (Node* self);
GType draw_area_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DrawArea, g_object_unref)
DrawArea* node_get_da (Node* self);
GArray* draw_area_get_nodes (DrawArea* self);
void draw_area_handle_tree_overlap (DrawArea* self,
                                    NodeBounds* prev);
static void layout_real_propagate_side (Layout* self,
                                 Node* parent,
                                 NodeSide side);
gpointer style_ref (gpointer instance);
void style_unref (gpointer instance);
GParamSpec* param_spec_style (const gchar* name,
                              const gchar* nick,
                              const gchar* blurb,
                              GType object_type,
                              GParamFlags flags);
void value_set_style (GValue* value,
                      gpointer v_object);
void value_take_style (GValue* value,
                       gpointer v_object);
gpointer value_get_style (const GValue* value);
GType style_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Style, style_unref)
Style* node_get_style (Node* self);
gint* style_get_branch_margin (Style* self);
static gint* _int_dup (gint* self);
static NodeSide layout_real_get_side (Layout* self,
                               Node* n);
Node* node_get_root (Node* self);
static void layout_real_set_side (Layout* self,
                           Node* current);
gboolean node_is_root (Node* self);
static void layout_real_handle_update_by_edit (Layout* self,
                                        Node* n,
                                        gdouble diffw,
                                        gdouble diffh);
void node_adjust_posy_only (Node* self,
                            gdouble value);
void node_adjust_posx_only (Node* self,
                            gdouble value);
static void layout_real_handle_update_by_fold (Layout* self,
                                        Node* n);
void layout_apply_margin (Layout* self,
                          Node* n);
gdouble node_task_width (Node* self);
static gdouble layout_real_get_insert_adjust (Layout* self,
                                       Node* child);
static void layout_real_handle_update_by_insert (Layout* self,
                                          Node* parent,
                                          Node* child,
                                          gint pos);
gint node_side_count (Node* self,
                      NodeSide side);
static void layout_real_handle_update_by_delete (Layout* self,
                                          Node* parent,
                                          gint index,
                                          NodeSide side,
                                          gdouble size);
static void layout_real_position_root (Layout* self,
                                Node* last,
                                Node* n);
const gchar* layout_get_name (Layout* self);
void layout_set_name (Layout* self,
                      const gchar* value);
const gchar* layout_get_icon (Layout* self);
void layout_set_icon (Layout* self,
                      const gchar* value);
gboolean layout_get_balanceable (Layout* self);
void layout_set_balanceable (Layout* self,
                             gboolean value);
static void layout_finalize (GObject * obj);
static GType layout_get_type_once (void);
static void _vala_layout_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec);
static void _vala_layout_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec);

static inline gpointer
layout_get_instance_private (Layout* self)
{
	return G_STRUCT_MEMBER_P (self, Layout_private_offset);
}

Layout*
layout_construct (GType object_type)
{
	Layout * self = NULL;
	self = (Layout*) g_object_new (object_type, NULL);
	return self;
}

Layout*
layout_new (void)
{
	return layout_construct (TYPE_LAYOUT);
}

static NodeSide
layout_real_side_mapping (Layout* self,
                          NodeSide side)
{
	NodeSide result = 0;
	switch (side) {
		case NODE_SIDE_LEFT:
		{
			result = NODE_SIDE_LEFT;
			return result;
		}
		case NODE_SIDE_RIGHT:
		{
			result = NODE_SIDE_RIGHT;
			return result;
		}
		case NODE_SIDE_TOP:
		{
			result = NODE_SIDE_LEFT;
			return result;
		}
		case NODE_SIDE_BOTTOM:
		{
			result = NODE_SIDE_RIGHT;
			return result;
		}
		default:
		break;
	}
	result = NODE_SIDE_RIGHT;
	return result;
}

NodeSide
layout_side_mapping (Layout* self,
                     NodeSide side)
{
	g_return_val_if_fail (self != NULL, 0);
	return LAYOUT_GET_CLASS (self)->side_mapping (self, side);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static Block18Data*
block18_data_ref (Block18Data* _data18_)
{
	g_atomic_int_inc (&_data18_->_ref_count_);
	return _data18_;
}

static void
block18_data_unref (void * _userdata_)
{
	Block18Data* _data18_;
	_data18_ = (Block18Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data18_->_ref_count_)) {
		Layout* self;
		self = _data18_->self;
		_g_object_unref0 (_data18_->parent);
		_g_object_unref0 (self);
		g_slice_free (Block18Data, _data18_);
	}
}

static void
__lambda35_ (Layout* self,
             Node* item)
{
	NodeSide _tmp0_;
	NodeSide _tmp1_;
	g_return_if_fail (item != NULL);
	_tmp0_ = node_get_side (item);
	_tmp1_ = _tmp0_;
	node_detach (item, _tmp1_);
}

static void
___lambda35__gfunc (gconstpointer data,
                    gpointer self)
{
	__lambda35_ ((Layout*) self, (Node*) data);
}

static void
__lambda52_ (Block18Data* _data18_,
             Node* item)
{
	Layout* self;
	self = _data18_->self;
	g_return_if_fail (item != NULL);
	node_attach_init (item, _data18_->parent, -1);
}

static void
___lambda52__gfunc (gconstpointer data,
                    gpointer self)
{
	__lambda52_ (self, (Node*) data);
}

static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

static inline void
_g_slist_free__g_object_unref0_ (GSList* self)
{
	g_slist_free_full (self, (GDestroyNotify) _g_object_unref0_);
}

static void
layout_real_initialize (Layout* self,
                        Node* parent)
{
	Block18Data* _data18_;
	Node* _tmp0_;
	GSList* list = NULL;
	GSList* _tmp18_;
	GSList* _tmp19_;
	g_return_if_fail (parent != NULL);
	_data18_ = g_slice_new0 (Block18Data);
	_data18_->_ref_count_ = 1;
	_data18_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (parent);
	_g_object_unref0 (_data18_->parent);
	_data18_->parent = _tmp0_;
	list = NULL;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				GArray* _tmp3_;
				GArray* _tmp4_;
				gboolean _tmp5_;
				Node* n = NULL;
				GArray* _tmp6_;
				GArray* _tmp7_;
				Node* _tmp8_;
				Node* _tmp9_;
				Node* _tmp10_;
				Node* _tmp11_;
				Node* _tmp12_;
				Node* _tmp13_;
				NodeSide _tmp14_;
				NodeSide _tmp15_;
				Node* _tmp16_;
				Node* _tmp17_;
				if (!_tmp1_) {
					gint _tmp2_;
					_tmp2_ = i;
					i = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				_tmp3_ = node_children (_data18_->parent);
				_tmp4_ = _tmp3_;
				_tmp5_ = !(((guint) i) < _tmp4_->len);
				_g_array_unref0 (_tmp4_);
				if (_tmp5_) {
					break;
				}
				_tmp6_ = node_children (_data18_->parent);
				_tmp7_ = _tmp6_;
				_tmp8_ = g_array_index (_tmp7_, Node*, (guint) i);
				_tmp9_ = _g_object_ref0 (_tmp8_);
				_tmp10_ = _tmp9_;
				_g_array_unref0 (_tmp7_);
				n = _tmp10_;
				_tmp11_ = n;
				layout_initialize (self, _tmp11_);
				_tmp12_ = n;
				_tmp13_ = n;
				_tmp14_ = node_get_side (_tmp13_);
				_tmp15_ = _tmp14_;
				node_set_side (_tmp12_, layout_side_mapping (self, _tmp15_));
				_tmp16_ = n;
				_tmp17_ = _g_object_ref0 (_tmp16_);
				list = g_slist_append (list, _tmp17_);
				_g_object_unref0 (n);
			}
		}
	}
	_tmp18_ = list;
	g_slist_foreach (_tmp18_, ___lambda35__gfunc, self);
	_tmp19_ = list;
	g_slist_foreach (_tmp19_, ___lambda52__gfunc, _data18_);
	(list == NULL) ? NULL : (list = (_g_slist_free__g_object_unref0_ (list), NULL));
	block18_data_unref (_data18_);
	_data18_ = NULL;
}

void
layout_initialize (Layout* self,
                   Node* parent)
{
	g_return_if_fail (self != NULL);
	LAYOUT_GET_CLASS (self)->initialize (self, parent);
}

static void
layout_real_bbox (Layout* self,
                  Node* parent,
                  gint side_mask,
                  NodeBounds* result)
{
	NodeBounds nb = {0};
	NodeBounds _tmp0_ = {0};
	guint num_children = 0U;
	GArray* _tmp1_;
	GArray* _tmp2_;
	guint _tmp3_;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble x2 = 0.0;
	NodeBounds _tmp8_;
	NodeBounds _tmp9_;
	gdouble y2 = 0.0;
	NodeBounds _tmp10_;
	NodeBounds _tmp11_;
	gboolean _tmp12_ = FALSE;
	NodeBounds _tmp52_;
	NodeBounds _tmp53_;
	g_return_if_fail (parent != NULL);
	_tmp0_.x = (gdouble) 0;
	_tmp0_.y = (gdouble) 0;
	_tmp0_.width = (gdouble) 0;
	_tmp0_.height = (gdouble) 0;
	nb = _tmp0_;
	_tmp1_ = node_children (parent);
	_tmp2_ = _tmp1_;
	_tmp3_ = _tmp2_->len;
	_g_array_unref0 (_tmp2_);
	num_children = _tmp3_;
	node_bbox (parent, &_tmp4_, &_tmp5_, &_tmp6_, &_tmp7_);
	nb.x = _tmp4_;
	nb.y = _tmp5_;
	nb.width = _tmp6_;
	nb.height = _tmp7_;
	_tmp8_ = nb;
	_tmp9_ = nb;
	x2 = _tmp8_.x + _tmp9_.width;
	_tmp10_ = nb;
	_tmp11_ = nb;
	y2 = _tmp10_.y + _tmp11_.height;
	if (num_children != ((guint) 0)) {
		gboolean _tmp13_;
		gboolean _tmp14_;
		_tmp13_ = node_get_folded (parent);
		_tmp14_ = _tmp13_;
		_tmp12_ = !_tmp14_;
	} else {
		_tmp12_ = FALSE;
	}
	if (_tmp12_) {
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp15_ = FALSE;
				_tmp15_ = TRUE;
				while (TRUE) {
					GArray* _tmp17_;
					GArray* _tmp18_;
					gboolean _tmp19_;
					GArray* _tmp20_;
					GArray* _tmp21_;
					Node* _tmp22_;
					NodeSide _tmp23_;
					NodeSide _tmp24_;
					gboolean _tmp25_;
					if (!_tmp15_) {
						gint _tmp16_;
						_tmp16_ = i;
						i = _tmp16_ + 1;
					}
					_tmp15_ = FALSE;
					_tmp17_ = node_children (parent);
					_tmp18_ = _tmp17_;
					_tmp19_ = !(((guint) i) < _tmp18_->len);
					_g_array_unref0 (_tmp18_);
					if (_tmp19_) {
						break;
					}
					_tmp20_ = node_children (parent);
					_tmp21_ = _tmp20_;
					_tmp22_ = g_array_index (_tmp21_, Node*, (guint) i);
					_tmp23_ = node_get_side (_tmp22_);
					_tmp24_ = _tmp23_;
					_tmp25_ = (_tmp24_ & side_mask) != 0;
					_g_array_unref0 (_tmp21_);
					if (_tmp25_) {
						NodeBounds cb = {0};
						GArray* _tmp26_;
						GArray* _tmp27_;
						Node* _tmp28_;
						NodeBounds _tmp29_ = {0};
						NodeBounds _tmp30_;
						NodeBounds _tmp31_;
						gdouble _tmp32_ = 0.0;
						NodeBounds _tmp33_;
						NodeBounds _tmp34_;
						gdouble _tmp37_ = 0.0;
						NodeBounds _tmp38_;
						NodeBounds _tmp39_;
						gdouble _tmp42_ = 0.0;
						NodeBounds _tmp43_;
						NodeBounds _tmp44_;
						gdouble _tmp47_ = 0.0;
						NodeBounds _tmp48_;
						NodeBounds _tmp49_;
						_tmp26_ = node_children (parent);
						_tmp27_ = _tmp26_;
						_tmp28_ = g_array_index (_tmp27_, Node*, (guint) i);
						node_get_tree_bbox (_tmp28_, &_tmp29_);
						_tmp30_ = _tmp29_;
						_tmp31_ = _tmp30_;
						_g_array_unref0 (_tmp27_);
						cb = _tmp31_;
						_tmp33_ = nb;
						_tmp34_ = cb;
						if (_tmp33_.x < _tmp34_.x) {
							NodeBounds _tmp35_;
							_tmp35_ = nb;
							_tmp32_ = _tmp35_.x;
						} else {
							NodeBounds _tmp36_;
							_tmp36_ = cb;
							_tmp32_ = _tmp36_.x;
						}
						nb.x = _tmp32_;
						_tmp38_ = nb;
						_tmp39_ = cb;
						if (_tmp38_.y < _tmp39_.y) {
							NodeBounds _tmp40_;
							_tmp40_ = nb;
							_tmp37_ = _tmp40_.y;
						} else {
							NodeBounds _tmp41_;
							_tmp41_ = cb;
							_tmp37_ = _tmp41_.y;
						}
						nb.y = _tmp37_;
						_tmp43_ = cb;
						_tmp44_ = cb;
						if (x2 < (_tmp43_.x + _tmp44_.width)) {
							NodeBounds _tmp45_;
							NodeBounds _tmp46_;
							_tmp45_ = cb;
							_tmp46_ = cb;
							_tmp42_ = _tmp45_.x + _tmp46_.width;
						} else {
							_tmp42_ = x2;
						}
						x2 = _tmp42_;
						_tmp48_ = cb;
						_tmp49_ = cb;
						if (y2 < (_tmp48_.y + _tmp49_.height)) {
							NodeBounds _tmp50_;
							NodeBounds _tmp51_;
							_tmp50_ = cb;
							_tmp51_ = cb;
							_tmp47_ = _tmp50_.y + _tmp51_.height;
						} else {
							_tmp47_ = y2;
						}
						y2 = _tmp47_;
					}
				}
			}
		}
	}
	_tmp52_ = nb;
	nb.width = x2 - _tmp52_.x;
	_tmp53_ = nb;
	nb.height = y2 - _tmp53_.y;
	*result = nb;
	return;
}

void
layout_bbox (Layout* self,
             Node* parent,
             gint side_mask,
             NodeBounds* result)
{
	g_return_if_fail (self != NULL);
	LAYOUT_GET_CLASS (self)->bbox (self, parent, side_mask, result);
}

void
layout_update_tree_size (Layout* self,
                         Node* n)
{
	NodeBounds nb = {0};
	NodeBounds _tmp0_ = {0};
	NodeBounds _tmp1_;
	gdouble _tmp2_ = 0.0;
	NodeSide _tmp3_;
	NodeSide _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (n != NULL);
	layout_bbox (self, n, -1, &_tmp0_);
	nb = _tmp0_;
	_tmp1_ = nb;
	node_set_tree_bbox (n, &_tmp1_);
	_tmp3_ = node_get_side (n);
	_tmp4_ = _tmp3_;
	if ((_tmp4_ & node_side_horizontal ()) != 0) {
		NodeBounds _tmp5_;
		_tmp5_ = nb;
		_tmp2_ = _tmp5_.height;
	} else {
		NodeBounds _tmp6_;
		_tmp6_ = nb;
		_tmp2_ = _tmp6_.width;
	}
	node_set_tree_size (n, _tmp2_);
}

gdouble
layout_get_adjust (Layout* self,
                   Node* parent)
{
	gdouble orig_tree_size = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_ = 0.0;
	gdouble result = 0.0;
	g_return_val_if_fail (self != NULL, 0.0);
	g_return_val_if_fail (parent != NULL, 0.0);
	_tmp0_ = node_get_tree_size (parent);
	_tmp1_ = _tmp0_;
	orig_tree_size = _tmp1_;
	layout_update_tree_size (self, parent);
	if (orig_tree_size == ((gdouble) 0)) {
		_tmp2_ = (gdouble) 0;
	} else {
		gdouble _tmp3_;
		gdouble _tmp4_;
		_tmp3_ = node_get_tree_size (parent);
		_tmp4_ = _tmp3_;
		_tmp2_ = _tmp4_ - orig_tree_size;
	}
	result = _tmp2_;
	return result;
}

static void
layout_real_adjust_tree (Layout* self,
                         Node* parent,
                         gint child_index,
                         gint side_mask,
                         gdouble amount)
{
	g_return_if_fail (parent != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				GArray* _tmp2_;
				GArray* _tmp3_;
				gboolean _tmp4_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = node_children (parent);
				_tmp3_ = _tmp2_;
				_tmp4_ = !(((guint) i) < _tmp3_->len);
				_g_array_unref0 (_tmp3_);
				if (_tmp4_) {
					break;
				}
				if (i != child_index) {
					Node* n = NULL;
					GArray* _tmp5_;
					GArray* _tmp6_;
					Node* _tmp7_;
					Node* _tmp8_;
					Node* _tmp9_;
					Node* _tmp10_;
					NodeSide _tmp11_;
					NodeSide _tmp12_;
					_tmp5_ = node_children (parent);
					_tmp6_ = _tmp5_;
					_tmp7_ = g_array_index (_tmp6_, Node*, (guint) i);
					_tmp8_ = _g_object_ref0 (_tmp7_);
					_tmp9_ = _tmp8_;
					_g_array_unref0 (_tmp6_);
					n = _tmp9_;
					_tmp10_ = n;
					_tmp11_ = node_get_side (_tmp10_);
					_tmp12_ = _tmp11_;
					if ((_tmp12_ & side_mask) != 0) {
						Node* _tmp13_;
						NodeSide _tmp14_;
						NodeSide _tmp15_;
						_tmp13_ = n;
						_tmp14_ = node_get_side (_tmp13_);
						_tmp15_ = _tmp14_;
						if ((_tmp15_ & node_side_horizontal ()) != 0) {
							Node* _tmp16_;
							Node* _tmp17_;
							gdouble _tmp18_;
							gdouble _tmp19_;
							_tmp16_ = n;
							_tmp17_ = n;
							_tmp18_ = node_get_posy (_tmp17_);
							_tmp19_ = _tmp18_;
							node_set_posy (_tmp17_, _tmp19_ + amount);
						} else {
							Node* _tmp20_;
							Node* _tmp21_;
							gdouble _tmp22_;
							gdouble _tmp23_;
							_tmp20_ = n;
							_tmp21_ = n;
							_tmp22_ = node_get_posx (_tmp21_);
							_tmp23_ = _tmp22_;
							node_set_posx (_tmp21_, _tmp23_ + amount);
						}
					}
					_g_object_unref0 (n);
				} else {
					amount = 0 - amount;
				}
			}
		}
	}
}

void
layout_adjust_tree (Layout* self,
                    Node* parent,
                    gint child_index,
                    gint side_mask,
                    gdouble amount)
{
	g_return_if_fail (self != NULL);
	LAYOUT_GET_CLASS (self)->adjust_tree (self, parent, child_index, side_mask, amount);
}

static void
layout_real_adjust_tree_all (Layout* self,
                             Node* n,
                             NodeBounds* prev,
                             gdouble amount,
                             const gchar* msg)
{
	Node* parent = NULL;
	Node* _tmp0_;
	Node* _tmp1_;
	Node* _tmp2_;
	Node* last = NULL;
	Node* _tmp3_;
	gint index = 0;
	GArray* nodes = NULL;
	DrawArea* _tmp4_;
	DrawArea* _tmp5_;
	GArray* _tmp6_;
	g_return_if_fail (n != NULL);
	g_return_if_fail (prev != NULL);
	g_return_if_fail (msg != NULL);
	_tmp0_ = node_get_parent (n);
	_tmp1_ = _tmp0_;
	_tmp2_ = _g_object_ref0 (_tmp1_);
	parent = _tmp2_;
	_tmp3_ = _g_object_ref0 (n);
	last = _tmp3_;
	index = node_index (n);
	_tmp4_ = node_get_da (n);
	_tmp5_ = _tmp4_;
	_tmp6_ = draw_area_get_nodes (_tmp5_);
	nodes = _tmp6_;
	while (TRUE) {
		Node* _tmp7_;
		Node* _tmp8_;
		NodeSide _tmp9_;
		NodeSide _tmp10_;
		Node* _tmp11_;
		NodeBounds _tmp12_ = {0};
		NodeBounds _tmp13_;
		Node* _tmp14_;
		Node* _tmp15_;
		Node* _tmp16_;
		Node* _tmp17_;
		Node* _tmp18_;
		Node* _tmp19_;
		Node* _tmp20_;
		Node* _tmp21_;
		_tmp7_ = parent;
		if (!(_tmp7_ != NULL)) {
			break;
		}
		_tmp8_ = parent;
		_tmp9_ = node_get_side (n);
		_tmp10_ = _tmp9_;
		layout_adjust_tree (self, _tmp8_, index, (gint) _tmp10_, amount);
		_tmp11_ = parent;
		node_get_tree_bbox (_tmp11_, &_tmp12_);
		_tmp13_ = _tmp12_;
		*prev = _tmp13_;
		_tmp14_ = parent;
		amount = 0 - (layout_get_adjust (self, _tmp14_) / 2);
		_tmp15_ = parent;
		index = node_index (_tmp15_);
		_tmp16_ = parent;
		_tmp17_ = _g_object_ref0 (_tmp16_);
		_g_object_unref0 (last);
		last = _tmp17_;
		_tmp18_ = parent;
		_tmp19_ = node_get_parent (_tmp18_);
		_tmp20_ = _tmp19_;
		_tmp21_ = _g_object_ref0 (_tmp20_);
		_g_object_unref0 (parent);
		parent = _tmp21_;
	}
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp22_ = FALSE;
			_tmp22_ = TRUE;
			while (TRUE) {
				GArray* _tmp24_;
				GArray* _tmp25_;
				Node* _tmp26_;
				Node* _tmp27_;
				if (!_tmp22_) {
					gint _tmp23_;
					_tmp23_ = i;
					i = _tmp23_ + 1;
				}
				_tmp22_ = FALSE;
				_tmp24_ = nodes;
				if (!(((guint) i) < _tmp24_->len)) {
					break;
				}
				_tmp25_ = nodes;
				_tmp26_ = g_array_index (_tmp25_, Node*, (guint) i);
				_tmp27_ = last;
				if (_tmp26_ == _tmp27_) {
					DrawArea* _tmp28_;
					DrawArea* _tmp29_;
					NodeBounds _tmp30_;
					_tmp28_ = node_get_da (n);
					_tmp29_ = _tmp28_;
					_tmp30_ = *prev;
					draw_area_handle_tree_overlap (_tmp29_, &_tmp30_);
				}
			}
		}
	}
	_g_array_unref0 (nodes);
	_g_object_unref0 (last);
	_g_object_unref0 (parent);
}

void
layout_adjust_tree_all (Layout* self,
                        Node* n,
                        NodeBounds* prev,
                        gdouble amount,
                        const gchar* msg)
{
	g_return_if_fail (self != NULL);
	LAYOUT_GET_CLASS (self)->adjust_tree_all (self, n, prev, amount, msg);
}

static gint*
_int_dup (gint* self)
{
	gint* dup;
	dup = g_new0 (gint, 1);
	memcpy (dup, self, sizeof (gint));
	return dup;
}

static gpointer
__int_dup0 (gpointer self)
{
	return self ? _int_dup (self) : NULL;
}

static void
layout_real_propagate_side (Layout* self,
                            Node* parent,
                            NodeSide side)
{
	gdouble px = 0.0;
	gdouble py = 0.0;
	gdouble pw = 0.0;
	gdouble ph = 0.0;
	gint* margin = NULL;
	Style* _tmp0_;
	Style* _tmp1_;
	gint* _tmp2_;
	gint* _tmp3_;
	gint* _tmp4_;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	g_return_if_fail (parent != NULL);
	_tmp0_ = node_get_style (parent);
	_tmp1_ = _tmp0_;
	_tmp2_ = style_get_branch_margin (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = __int_dup0 (_tmp3_);
	margin = _tmp4_;
	node_bbox (parent, &_tmp5_, &_tmp6_, &_tmp7_, &_tmp8_);
	px = _tmp5_;
	py = _tmp6_;
	pw = _tmp7_;
	ph = _tmp8_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp9_ = FALSE;
			_tmp9_ = TRUE;
			while (TRUE) {
				GArray* _tmp11_;
				GArray* _tmp12_;
				gboolean _tmp13_;
				Node* n = NULL;
				GArray* _tmp14_;
				GArray* _tmp15_;
				Node* _tmp16_;
				Node* _tmp17_;
				Node* _tmp18_;
				Node* _tmp19_;
				NodeSide _tmp20_;
				NodeSide _tmp21_;
				if (!_tmp9_) {
					gint _tmp10_;
					_tmp10_ = i;
					i = _tmp10_ + 1;
				}
				_tmp9_ = FALSE;
				_tmp11_ = node_children (parent);
				_tmp12_ = _tmp11_;
				_tmp13_ = !(((guint) i) < _tmp12_->len);
				_g_array_unref0 (_tmp12_);
				if (_tmp13_) {
					break;
				}
				_tmp14_ = node_children (parent);
				_tmp15_ = _tmp14_;
				_tmp16_ = g_array_index (_tmp15_, Node*, (guint) i);
				_tmp17_ = _g_object_ref0 (_tmp16_);
				_tmp18_ = _tmp17_;
				_g_array_unref0 (_tmp15_);
				n = _tmp18_;
				_tmp19_ = n;
				_tmp20_ = node_get_side (_tmp19_);
				_tmp21_ = _tmp20_;
				if (_tmp21_ != side) {
					Node* _tmp22_;
					Node* _tmp41_;
					_tmp22_ = n;
					node_set_side (_tmp22_, side);
					switch (side) {
						case NODE_SIDE_LEFT:
						{
							gdouble cx = 0.0;
							gdouble cy = 0.0;
							gdouble cw = 0.0;
							gdouble ch = 0.0;
							Node* _tmp23_;
							gdouble _tmp24_ = 0.0;
							gdouble _tmp25_ = 0.0;
							gdouble _tmp26_ = 0.0;
							gdouble _tmp27_ = 0.0;
							Node* _tmp28_;
							gint* _tmp29_;
							_tmp23_ = n;
							node_bbox (_tmp23_, &_tmp24_, &_tmp25_, &_tmp26_, &_tmp27_);
							cx = _tmp24_;
							cy = _tmp25_;
							cw = _tmp26_;
							ch = _tmp27_;
							_tmp28_ = n;
							_tmp29_ = margin;
							node_set_posx (_tmp28_, (px - (*_tmp29_)) - cw);
							break;
						}
						case NODE_SIDE_RIGHT:
						{
							Node* _tmp30_;
							gint* _tmp31_;
							_tmp30_ = n;
							_tmp31_ = margin;
							node_set_posx (_tmp30_, (px + pw) + (*_tmp31_));
							break;
						}
						case NODE_SIDE_TOP:
						{
							gdouble cx = 0.0;
							gdouble cy = 0.0;
							gdouble cw = 0.0;
							gdouble ch = 0.0;
							Node* _tmp32_;
							gdouble _tmp33_ = 0.0;
							gdouble _tmp34_ = 0.0;
							gdouble _tmp35_ = 0.0;
							gdouble _tmp36_ = 0.0;
							Node* _tmp37_;
							gint* _tmp38_;
							_tmp32_ = n;
							node_bbox (_tmp32_, &_tmp33_, &_tmp34_, &_tmp35_, &_tmp36_);
							cx = _tmp33_;
							cy = _tmp34_;
							cw = _tmp35_;
							ch = _tmp36_;
							_tmp37_ = n;
							_tmp38_ = margin;
							node_set_posy (_tmp37_, (py - (*_tmp38_)) - ch);
							break;
						}
						case NODE_SIDE_BOTTOM:
						{
							Node* _tmp39_;
							gint* _tmp40_;
							_tmp39_ = n;
							_tmp40_ = margin;
							node_set_posy (_tmp39_, (py + ph) + (*_tmp40_));
							break;
						}
						default:
						break;
					}
					_tmp41_ = n;
					layout_propagate_side (self, _tmp41_, side);
				}
				_g_object_unref0 (n);
			}
		}
	}
	_g_free0 (margin);
}

void
layout_propagate_side (Layout* self,
                       Node* parent,
                       NodeSide side)
{
	g_return_if_fail (self != NULL);
	LAYOUT_GET_CLASS (self)->propagate_side (self, parent, side);
}

static NodeSide
layout_real_get_side (Layout* self,
                      Node* n)
{
	gdouble rx = 0.0;
	gdouble ry = 0.0;
	gdouble rw = 0.0;
	gdouble rh = 0.0;
	gdouble nx = 0.0;
	gdouble ny = 0.0;
	gdouble nw = 0.0;
	gdouble nh = 0.0;
	Node* _tmp0_;
	Node* _tmp1_;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	NodeSide _tmp10_;
	NodeSide _tmp11_;
	NodeSide result = 0;
	g_return_val_if_fail (n != NULL, 0);
	_tmp0_ = node_get_root (n);
	_tmp1_ = _tmp0_;
	node_bbox (_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
	rx = _tmp2_;
	ry = _tmp3_;
	rw = _tmp4_;
	rh = _tmp5_;
	_g_object_unref0 (_tmp1_);
	node_bbox (n, &_tmp6_, &_tmp7_, &_tmp8_, &_tmp9_);
	nx = _tmp6_;
	ny = _tmp7_;
	nw = _tmp8_;
	nh = _tmp9_;
	_tmp10_ = node_get_side (n);
	_tmp11_ = _tmp10_;
	if ((_tmp11_ & node_side_horizontal ()) != 0) {
		NodeSide _tmp12_ = 0;
		if ((nx + (nw / 2)) > (rx + (rw / 2))) {
			_tmp12_ = NODE_SIDE_RIGHT;
		} else {
			_tmp12_ = NODE_SIDE_LEFT;
		}
		result = _tmp12_;
		return result;
	} else {
		NodeSide _tmp13_ = 0;
		if ((ny + (nh / 2)) > (ry + (rh / 2))) {
			_tmp13_ = NODE_SIDE_BOTTOM;
		} else {
			_tmp13_ = NODE_SIDE_TOP;
		}
		result = _tmp13_;
		return result;
	}
}

NodeSide
layout_get_side (Layout* self,
                 Node* n)
{
	g_return_val_if_fail (self != NULL, 0);
	return LAYOUT_GET_CLASS (self)->get_side (self, n);
}

static void
layout_real_set_side (Layout* self,
                      Node* current)
{
	g_return_if_fail (current != NULL);
	if (!node_is_root (current)) {
		NodeSide side = 0;
		NodeSide _tmp0_;
		NodeSide _tmp1_;
		NodeSide _tmp2_;
		side = layout_get_side (self, current);
		_tmp0_ = node_get_side (current);
		_tmp1_ = _tmp0_;
		_tmp2_ = side;
		if (_tmp1_ != _tmp2_) {
			NodeSide _tmp3_;
			NodeSide _tmp4_;
			_tmp3_ = side;
			node_set_side (current, _tmp3_);
			_tmp4_ = side;
			layout_propagate_side (self, current, _tmp4_);
		}
	}
}

void
layout_set_side (Layout* self,
                 Node* current)
{
	g_return_if_fail (self != NULL);
	LAYOUT_GET_CLASS (self)->set_side (self, current);
}

static void
layout_real_handle_update_by_edit (Layout* self,
                                   Node* n,
                                   gdouble diffw,
                                   gdouble diffh)
{
	gdouble adjust = 0.0;
	NodeSide _tmp0_;
	NodeSide _tmp1_;
	NodeBounds _tmp42_ = {0};
	NodeBounds _tmp43_;
	g_return_if_fail (n != NULL);
	adjust = 0 - (layout_get_adjust (self, n) / 2);
	_tmp0_ = node_get_side (n);
	_tmp1_ = _tmp0_;
	if ((_tmp1_ & node_side_horizontal ()) != 0) {
		gboolean _tmp2_ = FALSE;
		Node* _tmp3_;
		Node* _tmp4_;
		_tmp3_ = node_get_parent (n);
		_tmp4_ = _tmp3_;
		if (_tmp4_ != NULL) {
			_tmp2_ = diffh != ((gdouble) 0);
		} else {
			_tmp2_ = FALSE;
		}
		if (_tmp2_) {
			node_adjust_posy_only (n, 0 - (diffh / 2));
		}
		if (diffw != ((gdouble) 0)) {
			NodeSide _tmp5_;
			NodeSide _tmp6_;
			_tmp5_ = node_get_side (n);
			_tmp6_ = _tmp5_;
			if (_tmp6_ == NODE_SIDE_LEFT) {
				gdouble _tmp7_;
				gdouble _tmp8_;
				_tmp7_ = node_get_posx (n);
				_tmp8_ = _tmp7_;
				node_set_posx (n, _tmp8_ - diffw);
			} else {
				{
					gint i = 0;
					i = 0;
					{
						gboolean _tmp9_ = FALSE;
						_tmp9_ = TRUE;
						while (TRUE) {
							GArray* _tmp11_;
							GArray* _tmp12_;
							gboolean _tmp13_;
							GArray* _tmp14_;
							GArray* _tmp15_;
							Node* _tmp16_;
							GArray* _tmp17_;
							GArray* _tmp18_;
							Node* _tmp19_;
							gdouble _tmp20_;
							gdouble _tmp21_;
							if (!_tmp9_) {
								gint _tmp10_;
								_tmp10_ = i;
								i = _tmp10_ + 1;
							}
							_tmp9_ = FALSE;
							_tmp11_ = node_children (n);
							_tmp12_ = _tmp11_;
							_tmp13_ = !(((guint) i) < _tmp12_->len);
							_g_array_unref0 (_tmp12_);
							if (_tmp13_) {
								break;
							}
							_tmp14_ = node_children (n);
							_tmp15_ = _tmp14_;
							_tmp16_ = g_array_index (_tmp15_, Node*, (guint) i);
							_tmp17_ = node_children (n);
							_tmp18_ = _tmp17_;
							_tmp19_ = g_array_index (_tmp18_, Node*, (guint) i);
							_tmp20_ = node_get_posx (_tmp19_);
							_tmp21_ = _tmp20_;
							node_set_posx (_tmp19_, _tmp21_ + diffw);
							_g_array_unref0 (_tmp18_);
							_g_array_unref0 (_tmp15_);
						}
					}
				}
			}
		}
	} else {
		gboolean _tmp22_ = FALSE;
		Node* _tmp23_;
		Node* _tmp24_;
		_tmp23_ = node_get_parent (n);
		_tmp24_ = _tmp23_;
		if (_tmp24_ != NULL) {
			_tmp22_ = diffw != ((gdouble) 0);
		} else {
			_tmp22_ = FALSE;
		}
		if (_tmp22_) {
			node_adjust_posx_only (n, 0 - (diffw / 2));
		}
		if (diffh != ((gdouble) 0)) {
			NodeSide _tmp25_;
			NodeSide _tmp26_;
			_tmp25_ = node_get_side (n);
			_tmp26_ = _tmp25_;
			if (_tmp26_ == NODE_SIDE_TOP) {
				gdouble _tmp27_;
				gdouble _tmp28_;
				_tmp27_ = node_get_posy (n);
				_tmp28_ = _tmp27_;
				node_set_posy (n, _tmp28_ - diffh);
			} else {
				{
					gint i = 0;
					i = 0;
					{
						gboolean _tmp29_ = FALSE;
						_tmp29_ = TRUE;
						while (TRUE) {
							GArray* _tmp31_;
							GArray* _tmp32_;
							gboolean _tmp33_;
							GArray* _tmp34_;
							GArray* _tmp35_;
							Node* _tmp36_;
							GArray* _tmp37_;
							GArray* _tmp38_;
							Node* _tmp39_;
							gdouble _tmp40_;
							gdouble _tmp41_;
							if (!_tmp29_) {
								gint _tmp30_;
								_tmp30_ = i;
								i = _tmp30_ + 1;
							}
							_tmp29_ = FALSE;
							_tmp31_ = node_children (n);
							_tmp32_ = _tmp31_;
							_tmp33_ = !(((guint) i) < _tmp32_->len);
							_g_array_unref0 (_tmp32_);
							if (_tmp33_) {
								break;
							}
							_tmp34_ = node_children (n);
							_tmp35_ = _tmp34_;
							_tmp36_ = g_array_index (_tmp35_, Node*, (guint) i);
							_tmp37_ = node_children (n);
							_tmp38_ = _tmp37_;
							_tmp39_ = g_array_index (_tmp38_, Node*, (guint) i);
							_tmp40_ = node_get_posy (_tmp39_);
							_tmp41_ = _tmp40_;
							node_set_posy (_tmp39_, _tmp41_ + diffh);
							_g_array_unref0 (_tmp38_);
							_g_array_unref0 (_tmp35_);
						}
					}
				}
			}
		}
	}
	node_get_tree_bbox (n, &_tmp42_);
	_tmp43_ = _tmp42_;
	layout_adjust_tree_all (self, n, &_tmp43_, adjust, "by_edit");
}

void
layout_handle_update_by_edit (Layout* self,
                              Node* n,
                              gdouble diffw,
                              gdouble diffh)
{
	g_return_if_fail (self != NULL);
	LAYOUT_GET_CLASS (self)->handle_update_by_edit (self, n, diffw, diffh);
}

static void
layout_real_handle_update_by_fold (Layout* self,
                                   Node* n)
{
	NodeBounds _tmp0_ = {0};
	NodeBounds _tmp1_;
	g_return_if_fail (n != NULL);
	node_get_tree_bbox (n, &_tmp0_);
	_tmp1_ = _tmp0_;
	layout_adjust_tree_all (self, n, &_tmp1_, 0 - (layout_get_adjust (self, n) / 2), "by_fold");
}

void
layout_handle_update_by_fold (Layout* self,
                              Node* n)
{
	g_return_if_fail (self != NULL);
	LAYOUT_GET_CLASS (self)->handle_update_by_fold (self, n);
}

void
layout_apply_margin (Layout* self,
                     Node* n)
{
	gdouble px = 0.0;
	gdouble py = 0.0;
	gdouble pw = 0.0;
	gdouble ph = 0.0;
	gint* margin = NULL;
	Node* _tmp0_;
	Node* _tmp1_;
	Style* _tmp2_;
	Style* _tmp3_;
	gint* _tmp4_;
	gint* _tmp5_;
	gint* _tmp6_;
	Node* _tmp7_;
	Node* _tmp8_;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_ = 0.0;
	gdouble _tmp12_ = 0.0;
	NodeSide _tmp13_;
	NodeSide _tmp14_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (n != NULL);
	_tmp0_ = node_get_parent (n);
	_tmp1_ = _tmp0_;
	_tmp2_ = node_get_style (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = style_get_branch_margin (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = __int_dup0 (_tmp5_);
	margin = _tmp6_;
	_tmp7_ = node_get_parent (n);
	_tmp8_ = _tmp7_;
	node_bbox (_tmp8_, &_tmp9_, &_tmp10_, &_tmp11_, &_tmp12_);
	px = _tmp9_;
	py = _tmp10_;
	pw = _tmp11_;
	ph = _tmp12_;
	_tmp13_ = node_get_side (n);
	_tmp14_ = _tmp13_;
	switch (_tmp14_) {
		case NODE_SIDE_LEFT:
		{
			gdouble cx = 0.0;
			gdouble cy = 0.0;
			gdouble cw = 0.0;
			gdouble ch = 0.0;
			gdouble _tmp15_ = 0.0;
			gdouble _tmp16_ = 0.0;
			gdouble _tmp17_ = 0.0;
			gdouble _tmp18_ = 0.0;
			gint* _tmp19_;
			node_bbox (n, &_tmp15_, &_tmp16_, &_tmp17_, &_tmp18_);
			cx = _tmp15_;
			cy = _tmp16_;
			cw = _tmp17_;
			ch = _tmp18_;
			_tmp19_ = margin;
			node_set_posx (n, px - (cw + (*_tmp19_)));
			break;
		}
		case NODE_SIDE_RIGHT:
		{
			gint* _tmp20_;
			Node* _tmp21_;
			Node* _tmp22_;
			_tmp20_ = margin;
			_tmp21_ = node_get_parent (n);
			_tmp22_ = _tmp21_;
			node_set_posx (n, (px + (pw + (*_tmp20_))) - node_task_width (_tmp22_));
			break;
		}
		case NODE_SIDE_TOP:
		{
			gdouble cx = 0.0;
			gdouble cy = 0.0;
			gdouble cw = 0.0;
			gdouble ch = 0.0;
			gdouble _tmp23_ = 0.0;
			gdouble _tmp24_ = 0.0;
			gdouble _tmp25_ = 0.0;
			gdouble _tmp26_ = 0.0;
			gint* _tmp27_;
			node_bbox (n, &_tmp23_, &_tmp24_, &_tmp25_, &_tmp26_);
			cx = _tmp23_;
			cy = _tmp24_;
			cw = _tmp25_;
			ch = _tmp26_;
			_tmp27_ = margin;
			node_set_posy (n, py - (ch + (*_tmp27_)));
			break;
		}
		case NODE_SIDE_BOTTOM:
		{
			gint* _tmp28_;
			_tmp28_ = margin;
			node_set_posy (n, py + (ph + (*_tmp28_)));
			break;
		}
		default:
		break;
	}
	_g_free0 (margin);
}

static gdouble
layout_real_get_insert_adjust (Layout* self,
                               Node* child)
{
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble result = 0.0;
	g_return_val_if_fail (child != NULL, 0.0);
	_tmp0_ = node_get_tree_size (child);
	_tmp1_ = _tmp0_;
	result = _tmp1_ / 2;
	return result;
}

gdouble
layout_get_insert_adjust (Layout* self,
                          Node* child)
{
	g_return_val_if_fail (self != NULL, 0.0);
	return LAYOUT_GET_CLASS (self)->get_insert_adjust (self, child);
}

static void
layout_real_handle_update_by_insert (Layout* self,
                                     Node* parent,
                                     Node* child,
                                     gint pos)
{
	gdouble ox = 0.0;
	gdouble oy = 0.0;
	gdouble ow = 0.0;
	gdouble oh = 0.0;
	gdouble adjust = 0.0;
	NodeBounds cb = {0};
	NodeBounds _tmp0_ = {0};
	NodeBounds _tmp1_;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	NodeSide _tmp6_;
	NodeSide _tmp7_;
	NodeBounds _tmp53_ = {0};
	NodeBounds _tmp54_;
	g_return_if_fail (parent != NULL);
	g_return_if_fail (child != NULL);
	layout_update_tree_size (self, child);
	node_get_tree_bbox (child, &_tmp0_);
	_tmp1_ = _tmp0_;
	cb = _tmp1_;
	node_bbox (child, &_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
	ox = _tmp2_;
	oy = _tmp3_;
	ow = _tmp4_;
	oh = _tmp5_;
	layout_apply_margin (self, child);
	adjust = layout_get_insert_adjust (self, child);
	_tmp6_ = node_get_side (child);
	_tmp7_ = _tmp6_;
	if (node_side_count (parent, _tmp7_) == 1) {
		gdouble px = 0.0;
		gdouble py = 0.0;
		gdouble pw = 0.0;
		gdouble ph = 0.0;
		gdouble _tmp8_ = 0.0;
		gdouble _tmp9_ = 0.0;
		gdouble _tmp10_ = 0.0;
		gdouble _tmp11_ = 0.0;
		NodeSide _tmp12_;
		NodeSide _tmp13_;
		node_bbox (parent, &_tmp8_, &_tmp9_, &_tmp10_, &_tmp11_);
		px = _tmp8_;
		py = _tmp9_;
		pw = _tmp10_;
		ph = _tmp11_;
		_tmp12_ = node_get_side (child);
		_tmp13_ = _tmp12_;
		if ((_tmp13_ & node_side_horizontal ()) != 0) {
			node_set_posy (child, py + ((ph / 2) - (oh / 2)));
		} else {
			node_set_posx (child, px + ((pw / 2) - (ow / 2)));
		}
	} else {
		gboolean _tmp14_ = FALSE;
		GArray* _tmp15_;
		GArray* _tmp16_;
		gboolean _tmp17_;
		_tmp15_ = node_children (parent);
		_tmp16_ = _tmp15_;
		_tmp17_ = ((guint) (pos + 1)) == _tmp16_->len;
		_g_array_unref0 (_tmp16_);
		if (_tmp17_) {
			_tmp14_ = TRUE;
		} else {
			GArray* _tmp18_;
			GArray* _tmp19_;
			Node* _tmp20_;
			NodeSide _tmp21_;
			NodeSide _tmp22_;
			NodeSide _tmp23_;
			NodeSide _tmp24_;
			_tmp18_ = node_children (parent);
			_tmp19_ = _tmp18_;
			_tmp20_ = g_array_index (_tmp19_, Node*, (guint) (pos + 1));
			_tmp21_ = node_get_side (_tmp20_);
			_tmp22_ = _tmp21_;
			_tmp23_ = node_get_side (child);
			_tmp24_ = _tmp23_;
			_tmp14_ = _tmp22_ != _tmp24_;
			_g_array_unref0 (_tmp19_);
		}
		if (_tmp14_) {
			NodeBounds sb = {0};
			GArray* _tmp25_;
			GArray* _tmp26_;
			Node* _tmp27_;
			NodeSide _tmp28_;
			NodeSide _tmp29_;
			NodeBounds _tmp30_ = {0};
			NodeBounds _tmp31_;
			NodeSide _tmp32_;
			NodeSide _tmp33_;
			_tmp25_ = node_children (parent);
			_tmp26_ = _tmp25_;
			_tmp27_ = g_array_index (_tmp26_, Node*, (guint) (pos - 1));
			_tmp28_ = node_get_side (child);
			_tmp29_ = _tmp28_;
			layout_bbox (self, _tmp27_, (gint) _tmp29_, &_tmp30_);
			_tmp31_ = _tmp30_;
			_g_array_unref0 (_tmp26_);
			sb = _tmp31_;
			_tmp32_ = node_get_side (child);
			_tmp33_ = _tmp32_;
			if ((_tmp33_ & node_side_horizontal ()) != 0) {
				NodeBounds _tmp34_;
				NodeBounds _tmp35_;
				NodeBounds _tmp36_;
				_tmp34_ = sb;
				_tmp35_ = sb;
				_tmp36_ = cb;
				node_set_posy (child, ((_tmp34_.y + _tmp35_.height) + (oy - _tmp36_.y)) - adjust);
			} else {
				NodeBounds _tmp37_;
				NodeBounds _tmp38_;
				NodeBounds _tmp39_;
				_tmp37_ = sb;
				_tmp38_ = sb;
				_tmp39_ = cb;
				node_set_posx (child, ((_tmp37_.x + _tmp38_.width) + (ox - _tmp39_.x)) - adjust);
			}
		} else {
			NodeBounds sb = {0};
			GArray* _tmp40_;
			GArray* _tmp41_;
			Node* _tmp42_;
			NodeSide _tmp43_;
			NodeSide _tmp44_;
			NodeBounds _tmp45_ = {0};
			NodeBounds _tmp46_;
			NodeSide _tmp47_;
			NodeSide _tmp48_;
			_tmp40_ = node_children (parent);
			_tmp41_ = _tmp40_;
			_tmp42_ = g_array_index (_tmp41_, Node*, (guint) (pos + 1));
			_tmp43_ = node_get_side (child);
			_tmp44_ = _tmp43_;
			layout_bbox (self, _tmp42_, (gint) _tmp44_, &_tmp45_);
			_tmp46_ = _tmp45_;
			_g_array_unref0 (_tmp41_);
			sb = _tmp46_;
			_tmp47_ = node_get_side (child);
			_tmp48_ = _tmp47_;
			if ((_tmp48_ & node_side_horizontal ()) != 0) {
				NodeBounds _tmp49_;
				NodeBounds _tmp50_;
				_tmp49_ = sb;
				_tmp50_ = cb;
				node_set_posy (child, (_tmp49_.y + (oy - _tmp50_.y)) - adjust);
			} else {
				NodeBounds _tmp51_;
				NodeBounds _tmp52_;
				_tmp51_ = sb;
				_tmp52_ = cb;
				node_set_posx (child, (_tmp51_.x + (ox - _tmp52_.x)) - adjust);
			}
		}
	}
	node_get_tree_bbox (child, &_tmp53_);
	_tmp54_ = _tmp53_;
	layout_adjust_tree_all (self, child, &_tmp54_, 0 - adjust, "by_insert");
}

void
layout_handle_update_by_insert (Layout* self,
                                Node* parent,
                                Node* child,
                                gint pos)
{
	g_return_if_fail (self != NULL);
	LAYOUT_GET_CLASS (self)->handle_update_by_insert (self, parent, child, pos);
}

static void
layout_real_handle_update_by_delete (Layout* self,
                                     Node* parent,
                                     gint index,
                                     NodeSide side,
                                     gdouble size)
{
	gdouble adjust = 0.0;
	NodeBounds _tmp25_ = {0};
	NodeBounds _tmp26_;
	g_return_if_fail (parent != NULL);
	adjust = size / 2;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				GArray* _tmp2_;
				GArray* _tmp3_;
				gboolean _tmp4_;
				Node* n = NULL;
				GArray* _tmp5_;
				GArray* _tmp6_;
				Node* _tmp7_;
				Node* _tmp8_;
				Node* _tmp9_;
				Node* _tmp10_;
				NodeSide _tmp11_;
				NodeSide _tmp12_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = node_children (parent);
				_tmp3_ = _tmp2_;
				_tmp4_ = !(((guint) i) < _tmp3_->len);
				_g_array_unref0 (_tmp3_);
				if (_tmp4_) {
					break;
				}
				_tmp5_ = node_children (parent);
				_tmp6_ = _tmp5_;
				_tmp7_ = g_array_index (_tmp6_, Node*, (guint) i);
				_tmp8_ = _g_object_ref0 (_tmp7_);
				_tmp9_ = _tmp8_;
				_g_array_unref0 (_tmp6_);
				n = _tmp9_;
				_tmp10_ = n;
				_tmp11_ = node_get_side (_tmp10_);
				_tmp12_ = _tmp11_;
				if (_tmp12_ == side) {
					gdouble _tmp13_ = 0.0;
					gdouble current_adjust = 0.0;
					Node* _tmp14_;
					NodeSide _tmp15_;
					NodeSide _tmp16_;
					if (i >= index) {
						_tmp13_ = 0 - adjust;
					} else {
						_tmp13_ = adjust;
					}
					current_adjust = _tmp13_;
					_tmp14_ = n;
					_tmp15_ = node_get_side (_tmp14_);
					_tmp16_ = _tmp15_;
					if ((_tmp16_ & node_side_horizontal ()) != 0) {
						Node* _tmp17_;
						Node* _tmp18_;
						gdouble _tmp19_;
						gdouble _tmp20_;
						_tmp17_ = n;
						_tmp18_ = n;
						_tmp19_ = node_get_posy (_tmp18_);
						_tmp20_ = _tmp19_;
						node_set_posy (_tmp18_, _tmp20_ + current_adjust);
					} else {
						Node* _tmp21_;
						Node* _tmp22_;
						gdouble _tmp23_;
						gdouble _tmp24_;
						_tmp21_ = n;
						_tmp22_ = n;
						_tmp23_ = node_get_posx (_tmp22_);
						_tmp24_ = _tmp23_;
						node_set_posx (_tmp22_, _tmp24_ + current_adjust);
					}
				}
				_g_object_unref0 (n);
			}
		}
	}
	node_get_tree_bbox (parent, &_tmp25_);
	_tmp26_ = _tmp25_;
	layout_adjust_tree_all (self, parent, &_tmp26_, 0 - (layout_get_adjust (self, parent) / 2), "by_delete");
}

void
layout_handle_update_by_delete (Layout* self,
                                Node* parent,
                                gint index,
                                NodeSide side,
                                gdouble size)
{
	g_return_if_fail (self != NULL);
	LAYOUT_GET_CLASS (self)->handle_update_by_delete (self, parent, index, side, size);
}

static void
layout_real_position_root (Layout* self,
                           Node* last,
                           Node* n)
{
	NodeBounds nb = {0};
	NodeBounds _tmp0_ = {0};
	NodeBounds _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	NodeBounds _tmp4_;
	NodeBounds _tmp5_;
	g_return_if_fail (last != NULL);
	g_return_if_fail (n != NULL);
	node_get_tree_bbox (last, &_tmp0_);
	_tmp1_ = _tmp0_;
	nb = _tmp1_;
	_tmp2_ = node_get_posx (last);
	_tmp3_ = _tmp2_;
	node_set_posx (n, _tmp3_);
	_tmp4_ = nb;
	_tmp5_ = nb;
	node_set_posy (n, (_tmp4_.y + _tmp5_.height) + self->_rt_gap);
}

void
layout_position_root (Layout* self,
                      Node* last,
                      Node* n)
{
	g_return_if_fail (self != NULL);
	LAYOUT_GET_CLASS (self)->position_root (self, last, n);
}

const gchar*
layout_get_name (Layout* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_name;
	result = _tmp0_;
	return result;
}

void
layout_set_name (Layout* self,
                 const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, layout_get_name (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_name);
		self->priv->_name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, layout_properties[LAYOUT_NAME_PROPERTY]);
	}
}

const gchar*
layout_get_icon (Layout* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_icon;
	result = _tmp0_;
	return result;
}

void
layout_set_icon (Layout* self,
                 const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, layout_get_icon (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_icon);
		self->priv->_icon = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, layout_properties[LAYOUT_ICON_PROPERTY]);
	}
}

gboolean
layout_get_balanceable (Layout* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_balanceable;
	return result;
}

void
layout_set_balanceable (Layout* self,
                        gboolean value)
{
	g_return_if_fail (self != NULL);
	if (layout_get_balanceable (self) != value) {
		self->priv->_balanceable = value;
		g_object_notify_by_pspec ((GObject *) self, layout_properties[LAYOUT_BALANCEABLE_PROPERTY]);
	}
}

static void
layout_class_init (LayoutClass * klass,
                   gpointer klass_data)
{
	layout_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &Layout_private_offset);
	((LayoutClass *) klass)->side_mapping = (NodeSide (*) (Layout*, NodeSide)) layout_real_side_mapping;
	((LayoutClass *) klass)->initialize = (void (*) (Layout*, Node*)) layout_real_initialize;
	((LayoutClass *) klass)->bbox = (void (*) (Layout*, Node*, gint, NodeBounds*)) layout_real_bbox;
	((LayoutClass *) klass)->adjust_tree = (void (*) (Layout*, Node*, gint, gint, gdouble)) layout_real_adjust_tree;
	((LayoutClass *) klass)->adjust_tree_all = (void (*) (Layout*, Node*, NodeBounds*, gdouble, const gchar*)) layout_real_adjust_tree_all;
	((LayoutClass *) klass)->propagate_side = (void (*) (Layout*, Node*, NodeSide)) layout_real_propagate_side;
	((LayoutClass *) klass)->get_side = (NodeSide (*) (Layout*, Node*)) layout_real_get_side;
	((LayoutClass *) klass)->set_side = (void (*) (Layout*, Node*)) layout_real_set_side;
	((LayoutClass *) klass)->handle_update_by_edit = (void (*) (Layout*, Node*, gdouble, gdouble)) layout_real_handle_update_by_edit;
	((LayoutClass *) klass)->handle_update_by_fold = (void (*) (Layout*, Node*)) layout_real_handle_update_by_fold;
	((LayoutClass *) klass)->get_insert_adjust = (gdouble (*) (Layout*, Node*)) layout_real_get_insert_adjust;
	((LayoutClass *) klass)->handle_update_by_insert = (void (*) (Layout*, Node*, Node*, gint)) layout_real_handle_update_by_insert;
	((LayoutClass *) klass)->handle_update_by_delete = (void (*) (Layout*, Node*, gint, NodeSide, gdouble)) layout_real_handle_update_by_delete;
	((LayoutClass *) klass)->position_root = (void (*) (Layout*, Node*, Node*)) layout_real_position_root;
	G_OBJECT_CLASS (klass)->get_property = _vala_layout_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_layout_set_property;
	G_OBJECT_CLASS (klass)->finalize = layout_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), LAYOUT_NAME_PROPERTY, layout_properties[LAYOUT_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), LAYOUT_ICON_PROPERTY, layout_properties[LAYOUT_ICON_PROPERTY] = g_param_spec_string ("icon", "icon", "icon", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), LAYOUT_BALANCEABLE_PROPERTY, layout_properties[LAYOUT_BALANCEABLE_PROPERTY] = g_param_spec_boolean ("balanceable", "balanceable", "balanceable", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
layout_instance_init (Layout * self,
                      gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	self->priv = layout_get_instance_private (self);
	self->_rt_gap = (gdouble) 100;
	_tmp0_ = g_strdup ("");
	self->priv->_name = _tmp0_;
	_tmp1_ = g_strdup ("");
	self->priv->_icon = _tmp1_;
	self->priv->_balanceable = FALSE;
}

static void
layout_finalize (GObject * obj)
{
	Layout * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LAYOUT, Layout);
	_g_free0 (self->priv->_name);
	_g_free0 (self->priv->_icon);
	G_OBJECT_CLASS (layout_parent_class)->finalize (obj);
}

static GType
layout_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LayoutClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) layout_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Layout), 0, (GInstanceInitFunc) layout_instance_init, NULL };
	GType layout_type_id;
	layout_type_id = g_type_register_static (G_TYPE_OBJECT, "Layout", &g_define_type_info, 0);
	Layout_private_offset = g_type_add_instance_private (layout_type_id, sizeof (LayoutPrivate));
	return layout_type_id;
}

GType
layout_get_type (void)
{
	static volatile gsize layout_type_id__volatile = 0;
	if (g_once_init_enter (&layout_type_id__volatile)) {
		GType layout_type_id;
		layout_type_id = layout_get_type_once ();
		g_once_init_leave (&layout_type_id__volatile, layout_type_id);
	}
	return layout_type_id__volatile;
}

static void
_vala_layout_get_property (GObject * object,
                           guint property_id,
                           GValue * value,
                           GParamSpec * pspec)
{
	Layout * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_LAYOUT, Layout);
	switch (property_id) {
		case LAYOUT_NAME_PROPERTY:
		g_value_set_string (value, layout_get_name (self));
		break;
		case LAYOUT_ICON_PROPERTY:
		g_value_set_string (value, layout_get_icon (self));
		break;
		case LAYOUT_BALANCEABLE_PROPERTY:
		g_value_set_boolean (value, layout_get_balanceable (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_layout_set_property (GObject * object,
                           guint property_id,
                           const GValue * value,
                           GParamSpec * pspec)
{
	Layout * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_LAYOUT, Layout);
	switch (property_id) {
		case LAYOUT_NAME_PROPERTY:
		layout_set_name (self, g_value_get_string (value));
		break;
		case LAYOUT_ICON_PROPERTY:
		layout_set_icon (self, g_value_get_string (value));
		break;
		case LAYOUT_BALANCEABLE_PROPERTY:
		layout_set_balanceable (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

