/* NodesMenu.c generated by valac 0.48.9, the Vala compiler
 * generated from NodesMenu.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <granite.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>

#define TYPE_NODES_MENU (nodes_menu_get_type ())
#define NODES_MENU(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NODES_MENU, NodesMenu))
#define NODES_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NODES_MENU, NodesMenuClass))
#define IS_NODES_MENU(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NODES_MENU))
#define IS_NODES_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NODES_MENU))
#define NODES_MENU_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NODES_MENU, NodesMenuClass))

typedef struct _NodesMenu NodesMenu;
typedef struct _NodesMenuClass NodesMenuClass;
typedef struct _NodesMenuPrivate NodesMenuPrivate;

#define TYPE_DRAW_AREA (draw_area_get_type ())
#define DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DRAW_AREA, DrawArea))
#define DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DRAW_AREA, DrawAreaClass))
#define IS_DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DRAW_AREA))
#define IS_DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DRAW_AREA))
#define DRAW_AREA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DRAW_AREA, DrawAreaClass))

typedef struct _DrawArea DrawArea;
typedef struct _DrawAreaClass DrawAreaClass;
enum  {
	NODES_MENU_0_PROPERTY,
	NODES_MENU_NUM_PROPERTIES
};
static GParamSpec* nodes_menu_properties[NODES_MENU_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_NODE (node_get_type ())
#define NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NODE, Node))
#define NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NODE, NodeClass))
#define IS_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NODE))
#define IS_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NODE))
#define NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NODE, NodeClass))

typedef struct _Node Node;
typedef struct _NodeClass NodeClass;
#define _g_array_unref0(var) ((var == NULL) ? NULL : (var = (g_array_unref (var), NULL)))

#define TYPE_MAIN_WINDOW (main_window_get_type ())
#define MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MAIN_WINDOW, MainWindow))
#define MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MAIN_WINDOW, MainWindowClass))
#define IS_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MAIN_WINDOW))
#define IS_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MAIN_WINDOW))
#define MAIN_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MAIN_WINDOW, MainWindowClass))

typedef struct _MainWindow MainWindow;
typedef struct _MainWindowClass MainWindowClass;

struct _NodesMenu {
	GtkMenu parent_instance;
	NodesMenuPrivate * priv;
};

struct _NodesMenuClass {
	GtkMenuClass parent_class;
};

struct _NodesMenuPrivate {
	DrawArea* _da;
	GtkMenuItem* _copy;
	GtkMenuItem* _cut;
	GtkMenuItem* _delete;
	GtkMenuItem* _fold;
	GtkMenuItem* _connect;
	GtkMenuItem* _link;
	GtkMenuItem* _link_colors;
	GtkMenuItem* _parent_link_colors;
	GtkMenuItem* _align;
	GtkMenuItem* _selnodes;
	GtkMenuItem* _selparent;
	GtkMenuItem* _selchildren;
};

static gint NodesMenu_private_offset;
static gpointer nodes_menu_parent_class = NULL;

GType nodes_menu_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NodesMenu, g_object_unref)
GType draw_area_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DrawArea, g_object_unref)
NodesMenu* nodes_menu_new (DrawArea* da,
                           GtkAccelGroup* accel_group);
NodesMenu* nodes_menu_construct (GType object_type,
                                 DrawArea* da,
                                 GtkAccelGroup* accel_group);
static void nodes_menu_copy_nodes (NodesMenu* self);
static void _nodes_menu_copy_nodes_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                    gpointer self);
static void nodes_menu_cut_nodes (NodesMenu* self);
static void _nodes_menu_cut_nodes_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                   gpointer self);
static void nodes_menu_delete_nodes (NodesMenu* self);
static void _nodes_menu_delete_nodes_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                      gpointer self);
static void nodes_menu_fold_nodes (NodesMenu* self);
static void _nodes_menu_fold_nodes_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                    gpointer self);
static void nodes_menu_connect_nodes (NodesMenu* self);
static void _nodes_menu_connect_nodes_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                       gpointer self);
static void nodes_menu_link_nodes (NodesMenu* self);
static void _nodes_menu_link_nodes_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                    gpointer self);
static void nodes_menu_change_link_colors (NodesMenu* self);
static void _nodes_menu_change_link_colors_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                            gpointer self);
static void nodes_menu_randomize_link_colors (NodesMenu* self);
static void _nodes_menu_randomize_link_colors_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                               gpointer self);
static void nodes_menu_reparent_link_colors (NodesMenu* self);
static void _nodes_menu_reparent_link_colors_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                              gpointer self);
static void nodes_menu_select_parent_nodes (NodesMenu* self);
static void _nodes_menu_select_parent_nodes_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                             gpointer self);
static void nodes_menu_select_child_nodes (NodesMenu* self);
static void _nodes_menu_select_child_nodes_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                            gpointer self);
static void nodes_menu_align_to_top (NodesMenu* self);
static void _nodes_menu_align_to_top_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                      gpointer self);
static void nodes_menu_align_to_hcenter (NodesMenu* self);
static void _nodes_menu_align_to_hcenter_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                          gpointer self);
static void nodes_menu_align_to_bottom (NodesMenu* self);
static void _nodes_menu_align_to_bottom_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                         gpointer self);
static void nodes_menu_align_to_left (NodesMenu* self);
static void _nodes_menu_align_to_left_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                       gpointer self);
static void nodes_menu_align_to_vcenter (NodesMenu* self);
static void _nodes_menu_align_to_vcenter_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                          gpointer self);
static void nodes_menu_align_to_right (NodesMenu* self);
static void _nodes_menu_align_to_right_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                        gpointer self);
static void nodes_menu_on_popup (NodesMenu* self);
static void _nodes_menu_on_popup_gtk_widget_show (GtkWidget* _sender,
                                           gpointer self);
static void nodes_menu_nodes_foldable_status (NodesMenu* self,
                                       gboolean* foldable,
                                       gboolean* unfoldable);
GType node_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Node, g_object_unref)
GArray* draw_area_get_selected_nodes (DrawArea* self);
gboolean node_is_leaf (Node* self);
gboolean node_get_folded (Node* self);
static gboolean nodes_menu_link_colors_parentable (NodesMenu* self);
gboolean node_get_link_color_root (Node* self);
gboolean draw_area_nodes_alignable (DrawArea* self);
gboolean draw_area_parent_selectable (DrawArea* self);
gboolean draw_area_children_selectable (DrawArea* self);
void draw_area_do_copy (DrawArea* self);
void draw_area_do_cut (DrawArea* self);
void draw_area_delete_nodes (DrawArea* self);
void draw_area_toggle_folds (DrawArea* self);
void draw_area_create_connection (DrawArea* self);
void draw_area_create_links (DrawArea* self);
GType main_window_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MainWindow, g_object_unref)
MainWindow* draw_area_get_win (DrawArea* self);
void draw_area_change_link_colors (DrawArea* self,
                                   GdkRGBA* color);
void draw_area_randomize_link_colors (DrawArea* self);
void draw_area_reparent_link_colors (DrawArea* self);
void draw_area_select_parent_nodes (DrawArea* self);
void draw_area_select_child_nodes (DrawArea* self);
void node_align_align_top (DrawArea* da,
                           GArray* nodes);
void node_align_align_hcenter (DrawArea* da,
                               GArray* nodes);
void node_align_align_bottom (DrawArea* da,
                              GArray* nodes);
void node_align_align_left (DrawArea* da,
                            GArray* nodes);
void node_align_align_vcenter (DrawArea* da,
                               GArray* nodes);
void node_align_align_right (DrawArea* da,
                             GArray* nodes);
static void nodes_menu_finalize (GObject * obj);
static GType nodes_menu_get_type_once (void);

static inline gpointer
nodes_menu_get_instance_private (NodesMenu* self)
{
	return G_STRUCT_MEMBER_P (self, NodesMenu_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_nodes_menu_copy_nodes_gtk_menu_item_activate (GtkMenuItem* _sender,
                                               gpointer self)
{
	nodes_menu_copy_nodes ((NodesMenu*) self);
}

static void
_nodes_menu_cut_nodes_gtk_menu_item_activate (GtkMenuItem* _sender,
                                              gpointer self)
{
	nodes_menu_cut_nodes ((NodesMenu*) self);
}

static void
_nodes_menu_delete_nodes_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                 gpointer self)
{
	nodes_menu_delete_nodes ((NodesMenu*) self);
}

static void
_nodes_menu_fold_nodes_gtk_menu_item_activate (GtkMenuItem* _sender,
                                               gpointer self)
{
	nodes_menu_fold_nodes ((NodesMenu*) self);
}

static void
_nodes_menu_connect_nodes_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                  gpointer self)
{
	nodes_menu_connect_nodes ((NodesMenu*) self);
}

static void
_nodes_menu_link_nodes_gtk_menu_item_activate (GtkMenuItem* _sender,
                                               gpointer self)
{
	nodes_menu_link_nodes ((NodesMenu*) self);
}

static void
_nodes_menu_change_link_colors_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                       gpointer self)
{
	nodes_menu_change_link_colors ((NodesMenu*) self);
}

static void
_nodes_menu_randomize_link_colors_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                          gpointer self)
{
	nodes_menu_randomize_link_colors ((NodesMenu*) self);
}

static void
_nodes_menu_reparent_link_colors_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                         gpointer self)
{
	nodes_menu_reparent_link_colors ((NodesMenu*) self);
}

static void
_nodes_menu_select_parent_nodes_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                        gpointer self)
{
	nodes_menu_select_parent_nodes ((NodesMenu*) self);
}

static void
_nodes_menu_select_child_nodes_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                       gpointer self)
{
	nodes_menu_select_child_nodes ((NodesMenu*) self);
}

static void
_nodes_menu_align_to_top_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                 gpointer self)
{
	nodes_menu_align_to_top ((NodesMenu*) self);
}

static void
_nodes_menu_align_to_hcenter_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                     gpointer self)
{
	nodes_menu_align_to_hcenter ((NodesMenu*) self);
}

static void
_nodes_menu_align_to_bottom_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                    gpointer self)
{
	nodes_menu_align_to_bottom ((NodesMenu*) self);
}

static void
_nodes_menu_align_to_left_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                  gpointer self)
{
	nodes_menu_align_to_left ((NodesMenu*) self);
}

static void
_nodes_menu_align_to_vcenter_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                     gpointer self)
{
	nodes_menu_align_to_vcenter ((NodesMenu*) self);
}

static void
_nodes_menu_align_to_right_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                   gpointer self)
{
	nodes_menu_align_to_right ((NodesMenu*) self);
}

static void
_nodes_menu_on_popup_gtk_widget_show (GtkWidget* _sender,
                                      gpointer self)
{
	nodes_menu_on_popup ((NodesMenu*) self);
}

NodesMenu*
nodes_menu_construct (GType object_type,
                      DrawArea* da,
                      GtkAccelGroup* accel_group)
{
	NodesMenu * self = NULL;
	DrawArea* _tmp0_;
	GtkMenuItem* _tmp1_;
	GtkMenuItem* _tmp2_;
	GraniteAccelLabel* _tmp3_;
	GraniteAccelLabel* _tmp4_;
	GtkMenuItem* _tmp5_;
	GtkMenuItem* _tmp6_;
	GtkMenuItem* _tmp7_;
	GraniteAccelLabel* _tmp8_;
	GraniteAccelLabel* _tmp9_;
	GtkMenuItem* _tmp10_;
	GtkMenuItem* _tmp11_;
	GtkMenuItem* _tmp12_;
	GraniteAccelLabel* _tmp13_;
	GraniteAccelLabel* _tmp14_;
	GtkMenuItem* _tmp15_;
	GtkMenuItem* _tmp16_;
	GtkMenuItem* _tmp17_;
	GraniteAccelLabel* _tmp18_;
	GraniteAccelLabel* _tmp19_;
	GtkMenuItem* _tmp20_;
	GtkMenuItem* _tmp21_;
	GtkMenuItem* _tmp22_;
	GtkMenuItem* _tmp23_;
	GtkMenuItem* _tmp24_;
	GtkMenu* link_color_menu = NULL;
	GtkMenu* _tmp25_;
	GtkMenuItem* _tmp26_;
	GtkMenuItem* _tmp27_;
	GtkMenuItem* set_link_colors = NULL;
	GtkMenuItem* _tmp28_;
	GtkMenuItem* rand_link_colors = NULL;
	GtkMenuItem* _tmp29_;
	GtkMenuItem* _tmp30_;
	GtkMenuItem* _tmp31_;
	GtkMenuItem* _tmp32_;
	GtkMenu* selmenu = NULL;
	GtkMenu* _tmp33_;
	GtkMenuItem* _tmp34_;
	GtkMenuItem* _tmp35_;
	GtkMenuItem* _tmp36_;
	GtkMenuItem* _tmp37_;
	GraniteAccelLabel* _tmp38_;
	GraniteAccelLabel* _tmp39_;
	GtkMenuItem* _tmp40_;
	GtkMenuItem* _tmp41_;
	GtkMenuItem* _tmp42_;
	GraniteAccelLabel* _tmp43_;
	GraniteAccelLabel* _tmp44_;
	GtkMenuItem* _tmp45_;
	GtkMenuItem* _tmp46_;
	GtkMenuItem* _tmp47_;
	GtkMenu* align_menu = NULL;
	GtkMenu* _tmp48_;
	GtkMenuItem* _tmp49_;
	GtkMenuItem* _tmp50_;
	GtkMenuItem* align_top = NULL;
	GtkMenuItem* _tmp51_;
	GraniteAccelLabel* _tmp52_;
	GraniteAccelLabel* _tmp53_;
	GtkMenuItem* align_hcenter = NULL;
	GtkMenuItem* _tmp54_;
	GraniteAccelLabel* _tmp55_;
	GraniteAccelLabel* _tmp56_;
	GtkMenuItem* align_bottom = NULL;
	GtkMenuItem* _tmp57_;
	GraniteAccelLabel* _tmp58_;
	GraniteAccelLabel* _tmp59_;
	GtkMenuItem* align_left = NULL;
	GtkMenuItem* _tmp60_;
	GraniteAccelLabel* _tmp61_;
	GraniteAccelLabel* _tmp62_;
	GtkMenuItem* align_vcenter = NULL;
	GtkMenuItem* _tmp63_;
	GraniteAccelLabel* _tmp64_;
	GraniteAccelLabel* _tmp65_;
	GtkMenuItem* align_right = NULL;
	GtkMenuItem* _tmp66_;
	GraniteAccelLabel* _tmp67_;
	GraniteAccelLabel* _tmp68_;
	GtkSeparatorMenuItem* _tmp69_;
	GtkSeparatorMenuItem* _tmp70_;
	GtkMenuItem* _tmp71_;
	GtkMenuItem* _tmp72_;
	GtkMenuItem* _tmp73_;
	GtkSeparatorMenuItem* _tmp74_;
	GtkSeparatorMenuItem* _tmp75_;
	GtkMenuItem* _tmp76_;
	GtkMenuItem* _tmp77_;
	GtkSeparatorMenuItem* _tmp78_;
	GtkSeparatorMenuItem* _tmp79_;
	GtkMenuItem* _tmp80_;
	GtkMenuItem* _tmp81_;
	GtkSeparatorMenuItem* _tmp82_;
	GtkSeparatorMenuItem* _tmp83_;
	GtkMenuItem* _tmp84_;
	GtkSeparatorMenuItem* _tmp85_;
	GtkSeparatorMenuItem* _tmp86_;
	GtkMenuItem* _tmp87_;
	g_return_val_if_fail (da != NULL, NULL);
	g_return_val_if_fail (accel_group != NULL, NULL);
	self = (NodesMenu*) g_object_new (object_type, NULL);
	_tmp0_ = _g_object_ref0 (da);
	_g_object_unref0 (self->priv->_da);
	self->priv->_da = _tmp0_;
	_tmp1_ = (GtkMenuItem*) gtk_menu_item_new ();
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->priv->_copy);
	self->priv->_copy = _tmp1_;
	_tmp2_ = self->priv->_copy;
	_tmp3_ = granite_accel_label_new (_ ("Copy"), "<Control>c");
	g_object_ref_sink (_tmp3_);
	_tmp4_ = _tmp3_;
	gtk_container_add ((GtkContainer*) _tmp2_, (GtkWidget*) _tmp4_);
	_g_object_unref0 (_tmp4_);
	_tmp5_ = self->priv->_copy;
	g_signal_connect_object (_tmp5_, "activate", (GCallback) _nodes_menu_copy_nodes_gtk_menu_item_activate, self, 0);
	_tmp6_ = (GtkMenuItem*) gtk_menu_item_new ();
	g_object_ref_sink (_tmp6_);
	_g_object_unref0 (self->priv->_cut);
	self->priv->_cut = _tmp6_;
	_tmp7_ = self->priv->_cut;
	_tmp8_ = granite_accel_label_new (_ ("Cut"), "<Control>x");
	g_object_ref_sink (_tmp8_);
	_tmp9_ = _tmp8_;
	gtk_container_add ((GtkContainer*) _tmp7_, (GtkWidget*) _tmp9_);
	_g_object_unref0 (_tmp9_);
	_tmp10_ = self->priv->_cut;
	g_signal_connect_object (_tmp10_, "activate", (GCallback) _nodes_menu_cut_nodes_gtk_menu_item_activate, self, 0);
	_tmp11_ = (GtkMenuItem*) gtk_menu_item_new ();
	g_object_ref_sink (_tmp11_);
	_g_object_unref0 (self->priv->_delete);
	self->priv->_delete = _tmp11_;
	_tmp12_ = self->priv->_delete;
	_tmp13_ = granite_accel_label_new (_ ("Delete"), "Delete");
	g_object_ref_sink (_tmp13_);
	_tmp14_ = _tmp13_;
	gtk_container_add ((GtkContainer*) _tmp12_, (GtkWidget*) _tmp14_);
	_g_object_unref0 (_tmp14_);
	_tmp15_ = self->priv->_delete;
	g_signal_connect_object (_tmp15_, "activate", (GCallback) _nodes_menu_delete_nodes_gtk_menu_item_activate, self, 0);
	_tmp16_ = (GtkMenuItem*) gtk_menu_item_new ();
	g_object_ref_sink (_tmp16_);
	_g_object_unref0 (self->priv->_fold);
	self->priv->_fold = _tmp16_;
	_tmp17_ = self->priv->_fold;
	_tmp18_ = granite_accel_label_new (_ ("Fold Children"), "f");
	g_object_ref_sink (_tmp18_);
	_tmp19_ = _tmp18_;
	gtk_container_add ((GtkContainer*) _tmp17_, (GtkWidget*) _tmp19_);
	_g_object_unref0 (_tmp19_);
	_tmp20_ = self->priv->_fold;
	g_signal_connect_object (_tmp20_, "activate", (GCallback) _nodes_menu_fold_nodes_gtk_menu_item_activate, self, 0);
	_tmp21_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Connect"));
	g_object_ref_sink (_tmp21_);
	_g_object_unref0 (self->priv->_connect);
	self->priv->_connect = _tmp21_;
	_tmp22_ = self->priv->_connect;
	g_signal_connect_object (_tmp22_, "activate", (GCallback) _nodes_menu_connect_nodes_gtk_menu_item_activate, self, 0);
	_tmp23_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Link Nodes"));
	g_object_ref_sink (_tmp23_);
	_g_object_unref0 (self->priv->_link);
	self->priv->_link = _tmp23_;
	_tmp24_ = self->priv->_link;
	g_signal_connect_object (_tmp24_, "activate", (GCallback) _nodes_menu_link_nodes_gtk_menu_item_activate, self, 0);
	_tmp25_ = (GtkMenu*) gtk_menu_new ();
	g_object_ref_sink (_tmp25_);
	link_color_menu = _tmp25_;
	_tmp26_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Link Colors"));
	g_object_ref_sink (_tmp26_);
	_g_object_unref0 (self->priv->_link_colors);
	self->priv->_link_colors = _tmp26_;
	_tmp27_ = self->priv->_link_colors;
	gtk_menu_item_set_submenu (_tmp27_, link_color_menu);
	_tmp28_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Set to color…"));
	g_object_ref_sink (_tmp28_);
	set_link_colors = _tmp28_;
	g_signal_connect_object (set_link_colors, "activate", (GCallback) _nodes_menu_change_link_colors_gtk_menu_item_activate, self, 0);
	_tmp29_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Randomize colors"));
	g_object_ref_sink (_tmp29_);
	rand_link_colors = _tmp29_;
	g_signal_connect_object (rand_link_colors, "activate", (GCallback) _nodes_menu_randomize_link_colors_gtk_menu_item_activate, self, 0);
	_tmp30_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Use parent color"));
	g_object_ref_sink (_tmp30_);
	_g_object_unref0 (self->priv->_parent_link_colors);
	self->priv->_parent_link_colors = _tmp30_;
	_tmp31_ = self->priv->_parent_link_colors;
	g_signal_connect_object (_tmp31_, "activate", (GCallback) _nodes_menu_reparent_link_colors_gtk_menu_item_activate, self, 0);
	gtk_container_add ((GtkContainer*) link_color_menu, (GtkWidget*) set_link_colors);
	gtk_container_add ((GtkContainer*) link_color_menu, (GtkWidget*) rand_link_colors);
	_tmp32_ = self->priv->_parent_link_colors;
	gtk_container_add ((GtkContainer*) link_color_menu, (GtkWidget*) _tmp32_);
	_tmp33_ = (GtkMenu*) gtk_menu_new ();
	g_object_ref_sink (_tmp33_);
	selmenu = _tmp33_;
	_tmp34_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Select"));
	g_object_ref_sink (_tmp34_);
	_g_object_unref0 (self->priv->_selnodes);
	self->priv->_selnodes = _tmp34_;
	_tmp35_ = self->priv->_selnodes;
	gtk_menu_item_set_submenu (_tmp35_, selmenu);
	_tmp36_ = (GtkMenuItem*) gtk_menu_item_new ();
	g_object_ref_sink (_tmp36_);
	_g_object_unref0 (self->priv->_selparent);
	self->priv->_selparent = _tmp36_;
	_tmp37_ = self->priv->_selparent;
	_tmp38_ = granite_accel_label_new (_ ("Parent Nodes"), "a");
	g_object_ref_sink (_tmp38_);
	_tmp39_ = _tmp38_;
	gtk_container_add ((GtkContainer*) _tmp37_, (GtkWidget*) _tmp39_);
	_g_object_unref0 (_tmp39_);
	_tmp40_ = self->priv->_selparent;
	g_signal_connect_object (_tmp40_, "activate", (GCallback) _nodes_menu_select_parent_nodes_gtk_menu_item_activate, self, 0);
	_tmp41_ = (GtkMenuItem*) gtk_menu_item_new ();
	g_object_ref_sink (_tmp41_);
	_g_object_unref0 (self->priv->_selchildren);
	self->priv->_selchildren = _tmp41_;
	_tmp42_ = self->priv->_selchildren;
	_tmp43_ = granite_accel_label_new (_ ("Child Nodes"), "d");
	g_object_ref_sink (_tmp43_);
	_tmp44_ = _tmp43_;
	gtk_container_add ((GtkContainer*) _tmp42_, (GtkWidget*) _tmp44_);
	_g_object_unref0 (_tmp44_);
	_tmp45_ = self->priv->_selchildren;
	g_signal_connect_object (_tmp45_, "activate", (GCallback) _nodes_menu_select_child_nodes_gtk_menu_item_activate, self, 0);
	_tmp46_ = self->priv->_selparent;
	gtk_container_add ((GtkContainer*) selmenu, (GtkWidget*) _tmp46_);
	_tmp47_ = self->priv->_selchildren;
	gtk_container_add ((GtkContainer*) selmenu, (GtkWidget*) _tmp47_);
	_tmp48_ = (GtkMenu*) gtk_menu_new ();
	g_object_ref_sink (_tmp48_);
	align_menu = _tmp48_;
	_tmp49_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Align Nodes"));
	g_object_ref_sink (_tmp49_);
	_g_object_unref0 (self->priv->_align);
	self->priv->_align = _tmp49_;
	_tmp50_ = self->priv->_align;
	gtk_menu_item_set_submenu (_tmp50_, align_menu);
	_tmp51_ = (GtkMenuItem*) gtk_menu_item_new ();
	g_object_ref_sink (_tmp51_);
	align_top = _tmp51_;
	_tmp52_ = granite_accel_label_new (_ ("Align Top"), "minus");
	g_object_ref_sink (_tmp52_);
	_tmp53_ = _tmp52_;
	gtk_container_add ((GtkContainer*) align_top, (GtkWidget*) _tmp53_);
	_g_object_unref0 (_tmp53_);
	g_signal_connect_object (align_top, "activate", (GCallback) _nodes_menu_align_to_top_gtk_menu_item_activate, self, 0);
	_tmp54_ = (GtkMenuItem*) gtk_menu_item_new ();
	g_object_ref_sink (_tmp54_);
	align_hcenter = _tmp54_;
	_tmp55_ = granite_accel_label_new (_ ("Align Center Horizontally"), "equal");
	g_object_ref_sink (_tmp55_);
	_tmp56_ = _tmp55_;
	gtk_container_add ((GtkContainer*) align_hcenter, (GtkWidget*) _tmp56_);
	_g_object_unref0 (_tmp56_);
	g_signal_connect_object (align_hcenter, "activate", (GCallback) _nodes_menu_align_to_hcenter_gtk_menu_item_activate, self, 0);
	_tmp57_ = (GtkMenuItem*) gtk_menu_item_new ();
	g_object_ref_sink (_tmp57_);
	align_bottom = _tmp57_;
	_tmp58_ = granite_accel_label_new (_ ("Align Bottom"), "underscore");
	g_object_ref_sink (_tmp58_);
	_tmp59_ = _tmp58_;
	gtk_container_add ((GtkContainer*) align_bottom, (GtkWidget*) _tmp59_);
	_g_object_unref0 (_tmp59_);
	g_signal_connect_object (align_bottom, "activate", (GCallback) _nodes_menu_align_to_bottom_gtk_menu_item_activate, self, 0);
	_tmp60_ = (GtkMenuItem*) gtk_menu_item_new ();
	g_object_ref_sink (_tmp60_);
	align_left = _tmp60_;
	_tmp61_ = granite_accel_label_new (_ ("Align Left"), "bracketleft");
	g_object_ref_sink (_tmp61_);
	_tmp62_ = _tmp61_;
	gtk_container_add ((GtkContainer*) align_left, (GtkWidget*) _tmp62_);
	_g_object_unref0 (_tmp62_);
	g_signal_connect_object (align_left, "activate", (GCallback) _nodes_menu_align_to_left_gtk_menu_item_activate, self, 0);
	_tmp63_ = (GtkMenuItem*) gtk_menu_item_new ();
	g_object_ref_sink (_tmp63_);
	align_vcenter = _tmp63_;
	_tmp64_ = granite_accel_label_new (_ ("Align Center Vertically"), "bar");
	g_object_ref_sink (_tmp64_);
	_tmp65_ = _tmp64_;
	gtk_container_add ((GtkContainer*) align_vcenter, (GtkWidget*) _tmp65_);
	_g_object_unref0 (_tmp65_);
	g_signal_connect_object (align_vcenter, "activate", (GCallback) _nodes_menu_align_to_vcenter_gtk_menu_item_activate, self, 0);
	_tmp66_ = (GtkMenuItem*) gtk_menu_item_new ();
	g_object_ref_sink (_tmp66_);
	align_right = _tmp66_;
	_tmp67_ = granite_accel_label_new (_ ("Align Right"), "bracketright");
	g_object_ref_sink (_tmp67_);
	_tmp68_ = _tmp67_;
	gtk_container_add ((GtkContainer*) align_right, (GtkWidget*) _tmp68_);
	_g_object_unref0 (_tmp68_);
	g_signal_connect_object (align_right, "activate", (GCallback) _nodes_menu_align_to_right_gtk_menu_item_activate, self, 0);
	gtk_container_add ((GtkContainer*) align_menu, (GtkWidget*) align_top);
	gtk_container_add ((GtkContainer*) align_menu, (GtkWidget*) align_hcenter);
	gtk_container_add ((GtkContainer*) align_menu, (GtkWidget*) align_bottom);
	_tmp69_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
	g_object_ref_sink (_tmp69_);
	_tmp70_ = _tmp69_;
	gtk_container_add ((GtkContainer*) align_menu, (GtkWidget*) _tmp70_);
	_g_object_unref0 (_tmp70_);
	gtk_container_add ((GtkContainer*) align_menu, (GtkWidget*) align_left);
	gtk_container_add ((GtkContainer*) align_menu, (GtkWidget*) align_vcenter);
	gtk_container_add ((GtkContainer*) align_menu, (GtkWidget*) align_right);
	_tmp71_ = self->priv->_copy;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp71_);
	_tmp72_ = self->priv->_cut;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp72_);
	_tmp73_ = self->priv->_delete;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp73_);
	_tmp74_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
	g_object_ref_sink (_tmp74_);
	_tmp75_ = _tmp74_;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp75_);
	_g_object_unref0 (_tmp75_);
	_tmp76_ = self->priv->_link_colors;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp76_);
	_tmp77_ = self->priv->_fold;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp77_);
	_tmp78_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
	g_object_ref_sink (_tmp78_);
	_tmp79_ = _tmp78_;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp79_);
	_g_object_unref0 (_tmp79_);
	_tmp80_ = self->priv->_connect;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp80_);
	_tmp81_ = self->priv->_link;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp81_);
	_tmp82_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
	g_object_ref_sink (_tmp82_);
	_tmp83_ = _tmp82_;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp83_);
	_g_object_unref0 (_tmp83_);
	_tmp84_ = self->priv->_selnodes;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp84_);
	_tmp85_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
	g_object_ref_sink (_tmp85_);
	_tmp86_ = _tmp85_;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp86_);
	_g_object_unref0 (_tmp86_);
	_tmp87_ = self->priv->_align;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp87_);
	gtk_widget_show_all ((GtkWidget*) self);
	g_signal_connect_object ((GtkWidget*) self, "show", (GCallback) _nodes_menu_on_popup_gtk_widget_show, self, 0);
	_g_object_unref0 (align_right);
	_g_object_unref0 (align_vcenter);
	_g_object_unref0 (align_left);
	_g_object_unref0 (align_bottom);
	_g_object_unref0 (align_hcenter);
	_g_object_unref0 (align_top);
	_g_object_unref0 (align_menu);
	_g_object_unref0 (selmenu);
	_g_object_unref0 (rand_link_colors);
	_g_object_unref0 (set_link_colors);
	_g_object_unref0 (link_color_menu);
	return self;
}

NodesMenu*
nodes_menu_new (DrawArea* da,
                GtkAccelGroup* accel_group)
{
	return nodes_menu_construct (TYPE_NODES_MENU, da, accel_group);
}

static void
nodes_menu_nodes_foldable_status (NodesMenu* self,
                                  gboolean* foldable,
                                  gboolean* unfoldable)
{
	gboolean _vala_foldable = FALSE;
	gboolean _vala_unfoldable = FALSE;
	GArray* nodes = NULL;
	DrawArea* _tmp0_;
	GArray* _tmp1_;
	g_return_if_fail (self != NULL);
	_vala_unfoldable = FALSE;
	_vala_foldable = _vala_unfoldable;
	_tmp0_ = self->priv->_da;
	_tmp1_ = draw_area_get_selected_nodes (_tmp0_);
	nodes = _tmp1_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				GArray* _tmp4_;
				GArray* _tmp5_;
				Node* _tmp6_;
				if (!_tmp2_) {
					gint _tmp3_;
					_tmp3_ = i;
					i = _tmp3_ + 1;
				}
				_tmp2_ = FALSE;
				_tmp4_ = nodes;
				if (!(((guint) i) < _tmp4_->len)) {
					break;
				}
				_tmp5_ = nodes;
				_tmp6_ = g_array_index (_tmp5_, Node*, (guint) i);
				if (!node_is_leaf (_tmp6_)) {
					GArray* _tmp7_;
					Node* _tmp8_;
					gboolean _tmp9_;
					gboolean _tmp10_;
					GArray* _tmp11_;
					Node* _tmp12_;
					gboolean _tmp13_;
					gboolean _tmp14_;
					_tmp7_ = nodes;
					_tmp8_ = g_array_index (_tmp7_, Node*, (guint) i);
					_tmp9_ = node_get_folded (_tmp8_);
					_tmp10_ = _tmp9_;
					_vala_foldable = _vala_foldable | (!_tmp10_);
					_tmp11_ = nodes;
					_tmp12_ = g_array_index (_tmp11_, Node*, (guint) i);
					_tmp13_ = node_get_folded (_tmp12_);
					_tmp14_ = _tmp13_;
					_vala_unfoldable = _vala_unfoldable | _tmp14_;
				}
			}
		}
	}
	_g_array_unref0 (nodes);
	if (foldable) {
		*foldable = _vala_foldable;
	}
	if (unfoldable) {
		*unfoldable = _vala_unfoldable;
	}
}

static gboolean
nodes_menu_link_colors_parentable (NodesMenu* self)
{
	GArray* nodes = NULL;
	DrawArea* _tmp0_;
	GArray* _tmp1_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_da;
	_tmp1_ = draw_area_get_selected_nodes (_tmp0_);
	nodes = _tmp1_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				GArray* _tmp4_;
				GArray* _tmp5_;
				Node* _tmp6_;
				gboolean _tmp7_;
				gboolean _tmp8_;
				if (!_tmp2_) {
					gint _tmp3_;
					_tmp3_ = i;
					i = _tmp3_ + 1;
				}
				_tmp2_ = FALSE;
				_tmp4_ = nodes;
				if (!(((guint) i) < _tmp4_->len)) {
					break;
				}
				_tmp5_ = nodes;
				_tmp6_ = g_array_index (_tmp5_, Node*, (guint) i);
				_tmp7_ = node_get_link_color_root (_tmp6_);
				_tmp8_ = _tmp7_;
				if (_tmp8_) {
					result = TRUE;
					_g_array_unref0 (nodes);
					return result;
				}
			}
		}
	}
	result = FALSE;
	_g_array_unref0 (nodes);
	return result;
}

static void
nodes_menu_on_popup (NodesMenu* self)
{
	GArray* nodes = NULL;
	DrawArea* _tmp0_;
	GArray* _tmp1_;
	guint node_num = 0U;
	GArray* _tmp2_;
	gboolean foldable = FALSE;
	gboolean unfoldable = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	GtkMenuItem* _tmp6_;
	GtkMenuItem* _tmp7_;
	GtkMenuItem* _tmp8_;
	GtkMenuItem* _tmp9_;
	DrawArea* _tmp10_;
	GtkMenuItem* _tmp11_;
	DrawArea* _tmp12_;
	GtkMenuItem* _tmp13_;
	DrawArea* _tmp14_;
	const gchar* _tmp15_ = NULL;
	GtkMenuItem* _tmp16_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_da;
	_tmp1_ = draw_area_get_selected_nodes (_tmp0_);
	nodes = _tmp1_;
	_tmp2_ = nodes;
	node_num = _tmp2_->len;
	nodes_menu_nodes_foldable_status (self, &_tmp3_, &_tmp4_);
	foldable = _tmp3_;
	unfoldable = _tmp4_;
	if (foldable) {
		_tmp5_ = TRUE;
	} else {
		_tmp5_ = unfoldable;
	}
	_tmp6_ = self->priv->_fold;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp6_, _tmp5_);
	_tmp7_ = self->priv->_connect;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp7_, node_num == ((guint) 2));
	_tmp8_ = self->priv->_parent_link_colors;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp8_, nodes_menu_link_colors_parentable (self));
	_tmp9_ = self->priv->_align;
	_tmp10_ = self->priv->_da;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp9_, draw_area_nodes_alignable (_tmp10_));
	_tmp11_ = self->priv->_selparent;
	_tmp12_ = self->priv->_da;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp11_, draw_area_parent_selectable (_tmp12_));
	_tmp13_ = self->priv->_selchildren;
	_tmp14_ = self->priv->_da;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp13_, draw_area_children_selectable (_tmp14_));
	if (unfoldable) {
		_tmp15_ = _ ("Unfold Children");
	} else {
		_tmp15_ = _ ("Fold Children");
	}
	_tmp16_ = self->priv->_fold;
	gtk_menu_item_set_label (_tmp16_, _tmp15_);
	_g_array_unref0 (nodes);
}

static void
nodes_menu_copy_nodes (NodesMenu* self)
{
	DrawArea* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_da;
	draw_area_do_copy (_tmp0_);
}

static void
nodes_menu_cut_nodes (NodesMenu* self)
{
	DrawArea* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_da;
	draw_area_do_cut (_tmp0_);
}

static void
nodes_menu_delete_nodes (NodesMenu* self)
{
	DrawArea* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_da;
	draw_area_delete_nodes (_tmp0_);
}

static void
nodes_menu_fold_nodes (NodesMenu* self)
{
	DrawArea* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_da;
	draw_area_toggle_folds (_tmp0_);
}

static void
nodes_menu_connect_nodes (NodesMenu* self)
{
	DrawArea* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_da;
	draw_area_create_connection (_tmp0_);
}

static void
nodes_menu_link_nodes (NodesMenu* self)
{
	DrawArea* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_da;
	draw_area_create_links (_tmp0_);
}

static void
nodes_menu_change_link_colors (NodesMenu* self)
{
	GtkColorChooserDialog* color_picker = NULL;
	DrawArea* _tmp0_;
	MainWindow* _tmp1_;
	MainWindow* _tmp2_;
	GtkColorChooserDialog* _tmp3_;
	GtkColorChooserDialog* _tmp4_;
	GtkColorChooserDialog* _tmp8_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_da;
	_tmp1_ = draw_area_get_win (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = (GtkColorChooserDialog*) gtk_color_chooser_dialog_new (_ ("Select a link color"), (GtkWindow*) _tmp2_);
	g_object_ref_sink (_tmp3_);
	color_picker = _tmp3_;
	_tmp4_ = color_picker;
	if (gtk_dialog_run ((GtkDialog*) _tmp4_) == ((gint) GTK_RESPONSE_OK)) {
		DrawArea* _tmp5_;
		GtkColorChooserDialog* _tmp6_;
		GdkRGBA _tmp7_ = {0};
		_tmp5_ = self->priv->_da;
		_tmp6_ = color_picker;
		gtk_color_chooser_get_rgba ((GtkColorChooser*) _tmp6_, &_tmp7_);
		draw_area_change_link_colors (_tmp5_, &_tmp7_);
	}
	_tmp8_ = color_picker;
	g_signal_emit_by_name ((GtkDialog*) _tmp8_, "close");
	_g_object_unref0 (color_picker);
}

static void
nodes_menu_randomize_link_colors (NodesMenu* self)
{
	DrawArea* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_da;
	draw_area_randomize_link_colors (_tmp0_);
}

static void
nodes_menu_reparent_link_colors (NodesMenu* self)
{
	DrawArea* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_da;
	draw_area_reparent_link_colors (_tmp0_);
}

static void
nodes_menu_select_parent_nodes (NodesMenu* self)
{
	DrawArea* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_da;
	draw_area_select_parent_nodes (_tmp0_);
}

static void
nodes_menu_select_child_nodes (NodesMenu* self)
{
	DrawArea* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_da;
	draw_area_select_child_nodes (_tmp0_);
}

static void
nodes_menu_align_to_top (NodesMenu* self)
{
	DrawArea* _tmp0_;
	DrawArea* _tmp1_;
	GArray* _tmp2_;
	GArray* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_da;
	_tmp1_ = self->priv->_da;
	_tmp2_ = draw_area_get_selected_nodes (_tmp1_);
	_tmp3_ = _tmp2_;
	node_align_align_top (_tmp0_, _tmp3_);
	_g_array_unref0 (_tmp3_);
}

static void
nodes_menu_align_to_hcenter (NodesMenu* self)
{
	DrawArea* _tmp0_;
	DrawArea* _tmp1_;
	GArray* _tmp2_;
	GArray* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_da;
	_tmp1_ = self->priv->_da;
	_tmp2_ = draw_area_get_selected_nodes (_tmp1_);
	_tmp3_ = _tmp2_;
	node_align_align_hcenter (_tmp0_, _tmp3_);
	_g_array_unref0 (_tmp3_);
}

static void
nodes_menu_align_to_bottom (NodesMenu* self)
{
	DrawArea* _tmp0_;
	DrawArea* _tmp1_;
	GArray* _tmp2_;
	GArray* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_da;
	_tmp1_ = self->priv->_da;
	_tmp2_ = draw_area_get_selected_nodes (_tmp1_);
	_tmp3_ = _tmp2_;
	node_align_align_bottom (_tmp0_, _tmp3_);
	_g_array_unref0 (_tmp3_);
}

static void
nodes_menu_align_to_left (NodesMenu* self)
{
	DrawArea* _tmp0_;
	DrawArea* _tmp1_;
	GArray* _tmp2_;
	GArray* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_da;
	_tmp1_ = self->priv->_da;
	_tmp2_ = draw_area_get_selected_nodes (_tmp1_);
	_tmp3_ = _tmp2_;
	node_align_align_left (_tmp0_, _tmp3_);
	_g_array_unref0 (_tmp3_);
}

static void
nodes_menu_align_to_vcenter (NodesMenu* self)
{
	DrawArea* _tmp0_;
	DrawArea* _tmp1_;
	GArray* _tmp2_;
	GArray* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_da;
	_tmp1_ = self->priv->_da;
	_tmp2_ = draw_area_get_selected_nodes (_tmp1_);
	_tmp3_ = _tmp2_;
	node_align_align_vcenter (_tmp0_, _tmp3_);
	_g_array_unref0 (_tmp3_);
}

static void
nodes_menu_align_to_right (NodesMenu* self)
{
	DrawArea* _tmp0_;
	DrawArea* _tmp1_;
	GArray* _tmp2_;
	GArray* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_da;
	_tmp1_ = self->priv->_da;
	_tmp2_ = draw_area_get_selected_nodes (_tmp1_);
	_tmp3_ = _tmp2_;
	node_align_align_right (_tmp0_, _tmp3_);
	_g_array_unref0 (_tmp3_);
}

static void
nodes_menu_class_init (NodesMenuClass * klass,
                       gpointer klass_data)
{
	nodes_menu_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NodesMenu_private_offset);
	G_OBJECT_CLASS (klass)->finalize = nodes_menu_finalize;
}

static void
nodes_menu_instance_init (NodesMenu * self,
                          gpointer klass)
{
	self->priv = nodes_menu_get_instance_private (self);
}

static void
nodes_menu_finalize (GObject * obj)
{
	NodesMenu * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NODES_MENU, NodesMenu);
	_g_object_unref0 (self->priv->_da);
	_g_object_unref0 (self->priv->_copy);
	_g_object_unref0 (self->priv->_cut);
	_g_object_unref0 (self->priv->_delete);
	_g_object_unref0 (self->priv->_fold);
	_g_object_unref0 (self->priv->_connect);
	_g_object_unref0 (self->priv->_link);
	_g_object_unref0 (self->priv->_link_colors);
	_g_object_unref0 (self->priv->_parent_link_colors);
	_g_object_unref0 (self->priv->_align);
	_g_object_unref0 (self->priv->_selnodes);
	_g_object_unref0 (self->priv->_selparent);
	_g_object_unref0 (self->priv->_selchildren);
	G_OBJECT_CLASS (nodes_menu_parent_class)->finalize (obj);
}

static GType
nodes_menu_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NodesMenuClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nodes_menu_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NodesMenu), 0, (GInstanceInitFunc) nodes_menu_instance_init, NULL };
	GType nodes_menu_type_id;
	nodes_menu_type_id = g_type_register_static (gtk_menu_get_type (), "NodesMenu", &g_define_type_info, 0);
	NodesMenu_private_offset = g_type_add_instance_private (nodes_menu_type_id, sizeof (NodesMenuPrivate));
	return nodes_menu_type_id;
}

GType
nodes_menu_get_type (void)
{
	static volatile gsize nodes_menu_type_id__volatile = 0;
	if (g_once_init_enter (&nodes_menu_type_id__volatile)) {
		GType nodes_menu_type_id;
		nodes_menu_type_id = nodes_menu_get_type_once ();
		g_once_init_leave (&nodes_menu_type_id__volatile, nodes_menu_type_id);
	}
	return nodes_menu_type_id__volatile;
}

