/* AnimatorScale.c generated by valac 0.48.9, the Vala compiler
 * generated from AnimatorScale.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/

#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <float.h>
#include <math.h>

#define TYPE_ANIMATOR_ACTION (animator_action_get_type ())
#define ANIMATOR_ACTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ANIMATOR_ACTION, AnimatorAction))
#define ANIMATOR_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ANIMATOR_ACTION, AnimatorActionClass))
#define IS_ANIMATOR_ACTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ANIMATOR_ACTION))
#define IS_ANIMATOR_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ANIMATOR_ACTION))
#define ANIMATOR_ACTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ANIMATOR_ACTION, AnimatorActionClass))

typedef struct _AnimatorAction AnimatorAction;
typedef struct _AnimatorActionClass AnimatorActionClass;
typedef struct _AnimatorActionPrivate AnimatorActionPrivate;
typedef enum  {
	ANIMATION_TYPE_UNKNOWN = 0,
	ANIMATION_TYPE_NODES,
	ANIMATION_TYPE_NODE,
	ANIMATION_TYPE_PAN,
	ANIMATION_TYPE_SCALE,
	ANIMATION_TYPE_PANSCALE
} AnimationType;

#define TYPE_ANIMATION_TYPE (animation_type_get_type ())

#define TYPE_DRAW_AREA (draw_area_get_type ())
#define DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DRAW_AREA, DrawArea))
#define DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DRAW_AREA, DrawAreaClass))
#define IS_DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DRAW_AREA))
#define IS_DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DRAW_AREA))
#define DRAW_AREA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DRAW_AREA, DrawAreaClass))

typedef struct _DrawArea DrawArea;
typedef struct _DrawAreaClass DrawAreaClass;

#define TYPE_ANIMATOR_SCALE (animator_scale_get_type ())
#define ANIMATOR_SCALE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ANIMATOR_SCALE, AnimatorScale))
#define ANIMATOR_SCALE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ANIMATOR_SCALE, AnimatorScaleClass))
#define IS_ANIMATOR_SCALE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ANIMATOR_SCALE))
#define IS_ANIMATOR_SCALE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ANIMATOR_SCALE))
#define ANIMATOR_SCALE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ANIMATOR_SCALE, AnimatorScaleClass))

typedef struct _AnimatorScale AnimatorScale;
typedef struct _AnimatorScaleClass AnimatorScaleClass;
typedef struct _AnimatorScalePrivate AnimatorScalePrivate;
enum  {
	ANIMATOR_SCALE_0_PROPERTY,
	ANIMATOR_SCALE_NUM_PROPERTIES
};
static GParamSpec* animator_scale_properties[ANIMATOR_SCALE_NUM_PROPERTIES];
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))

struct _AnimatorAction {
	GObject parent_instance;
	AnimatorActionPrivate * priv;
	gchar* _name;
	gint _id;
};

struct _AnimatorActionClass {
	GObjectClass parent_class;
	AnimationType (*type) (AnimatorAction* self);
	void (*capture) (AnimatorAction* self, DrawArea* da);
	void (*adjust) (AnimatorAction* self, DrawArea* da);
};

struct _AnimatorScale {
	AnimatorAction parent_instance;
	AnimatorScalePrivate * priv;
};

struct _AnimatorScaleClass {
	AnimatorActionClass parent_class;
};

struct _AnimatorScalePrivate {
	gdouble* _sscale;
	gdouble* _escale;
};

static gint AnimatorScale_private_offset;
static gpointer animator_scale_parent_class = NULL;

GType animator_action_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AnimatorAction, g_object_unref)
GType animation_type_get_type (void) G_GNUC_CONST;
GType draw_area_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DrawArea, g_object_unref)
GType animator_scale_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AnimatorScale, g_object_unref)
AnimationType animator_action_type (AnimatorAction* self);
void animator_action_capture (AnimatorAction* self,
                              DrawArea* da);
void animator_action_adjust (AnimatorAction* self,
                             DrawArea* da);
AnimatorScale* animator_scale_new (DrawArea* da,
                                   const gchar* name);
AnimatorScale* animator_scale_construct (GType object_type,
                                         DrawArea* da,
                                         const gchar* name);
AnimatorAction* animator_action_new (const gchar* name);
AnimatorAction* animator_action_construct (GType object_type,
                                           const gchar* name);
gdouble draw_area_get_sfactor (DrawArea* self);
static gdouble* _double_dup (gdouble* self);
static AnimationType animator_scale_real_type (AnimatorAction* base);
static void animator_scale_real_capture (AnimatorAction* base,
                                  DrawArea* da);
static void animator_scale_real_adjust (AnimatorAction* base,
                                 DrawArea* da);
gint animator_action_get_index (AnimatorAction* self);
gdouble animator_action_get_frames (AnimatorAction* self);
void animator_action_set_index (AnimatorAction* self,
                                gint value);
void draw_area_set_scaling_factor (DrawArea* self,
                                   gdouble sf);
static void animator_scale_finalize (GObject * obj);
static GType animator_scale_get_type_once (void);

static inline gpointer
animator_scale_get_instance_private (AnimatorScale* self)
{
	return G_STRUCT_MEMBER_P (self, AnimatorScale_private_offset);
}

static gdouble*
_double_dup (gdouble* self)
{
	gdouble* dup;
	dup = g_new0 (gdouble, 1);
	memcpy (dup, self, sizeof (gdouble));
	return dup;
}

static gpointer
__double_dup0 (gpointer self)
{
	return self ? _double_dup (self) : NULL;
}

AnimatorScale*
animator_scale_construct (GType object_type,
                          DrawArea* da,
                          const gchar* name)
{
	AnimatorScale * self = NULL;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble* _tmp2_;
	g_return_val_if_fail (da != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	self = (AnimatorScale*) animator_action_construct (object_type, name);
	_tmp0_ = draw_area_get_sfactor (da);
	_tmp1_ = _tmp0_;
	_tmp2_ = __double_dup0 (&_tmp1_);
	_g_free0 (self->priv->_sscale);
	self->priv->_sscale = _tmp2_;
	return self;
}

AnimatorScale*
animator_scale_new (DrawArea* da,
                    const gchar* name)
{
	return animator_scale_construct (TYPE_ANIMATOR_SCALE, da, name);
}

static AnimationType
animator_scale_real_type (AnimatorAction* base)
{
	AnimatorScale * self;
	AnimationType result = 0;
	self = (AnimatorScale*) base;
	result = ANIMATION_TYPE_SCALE;
	return result;
}

static void
animator_scale_real_capture (AnimatorAction* base,
                             DrawArea* da)
{
	AnimatorScale * self;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble* _tmp2_;
	self = (AnimatorScale*) base;
	g_return_if_fail (da != NULL);
	_tmp0_ = draw_area_get_sfactor (da);
	_tmp1_ = _tmp0_;
	_tmp2_ = __double_dup0 (&_tmp1_);
	_g_free0 (self->priv->_escale);
	self->priv->_escale = _tmp2_;
}

static void
animator_scale_real_adjust (AnimatorAction* base,
                            DrawArea* da)
{
	AnimatorScale * self;
	gdouble divisor = 0.0;
	gint _tmp0_;
	gint _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gdouble sf = 0.0;
	gdouble* _tmp6_;
	gdouble* _tmp7_;
	gdouble* _tmp8_;
	self = (AnimatorScale*) base;
	g_return_if_fail (da != NULL);
	_tmp0_ = animator_action_get_index ((AnimatorAction*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = animator_action_get_frames ((AnimatorAction*) self);
	_tmp3_ = _tmp2_;
	divisor = _tmp1_ / _tmp3_;
	_tmp4_ = animator_action_get_index ((AnimatorAction*) self);
	_tmp5_ = _tmp4_;
	animator_action_set_index ((AnimatorAction*) self, _tmp5_ + 1);
	_tmp6_ = self->priv->_sscale;
	_tmp7_ = self->priv->_escale;
	_tmp8_ = self->priv->_sscale;
	sf = (*_tmp6_) + (((*_tmp7_) - (*_tmp8_)) * divisor);
	draw_area_set_scaling_factor (da, sf);
}

static void
animator_scale_class_init (AnimatorScaleClass * klass,
                           gpointer klass_data)
{
	animator_scale_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &AnimatorScale_private_offset);
	((AnimatorActionClass *) klass)->type = (AnimationType (*) (AnimatorAction*)) animator_scale_real_type;
	((AnimatorActionClass *) klass)->capture = (void (*) (AnimatorAction*, DrawArea*)) animator_scale_real_capture;
	((AnimatorActionClass *) klass)->adjust = (void (*) (AnimatorAction*, DrawArea*)) animator_scale_real_adjust;
	G_OBJECT_CLASS (klass)->finalize = animator_scale_finalize;
}

static void
animator_scale_instance_init (AnimatorScale * self,
                              gpointer klass)
{
	self->priv = animator_scale_get_instance_private (self);
	self->priv->_sscale = NULL;
	self->priv->_escale = NULL;
}

static void
animator_scale_finalize (GObject * obj)
{
	AnimatorScale * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ANIMATOR_SCALE, AnimatorScale);
	_g_free0 (self->priv->_sscale);
	_g_free0 (self->priv->_escale);
	G_OBJECT_CLASS (animator_scale_parent_class)->finalize (obj);
}

static GType
animator_scale_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AnimatorScaleClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) animator_scale_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AnimatorScale), 0, (GInstanceInitFunc) animator_scale_instance_init, NULL };
	GType animator_scale_type_id;
	animator_scale_type_id = g_type_register_static (TYPE_ANIMATOR_ACTION, "AnimatorScale", &g_define_type_info, 0);
	AnimatorScale_private_offset = g_type_add_instance_private (animator_scale_type_id, sizeof (AnimatorScalePrivate));
	return animator_scale_type_id;
}

GType
animator_scale_get_type (void)
{
	static volatile gsize animator_scale_type_id__volatile = 0;
	if (g_once_init_enter (&animator_scale_type_id__volatile)) {
		GType animator_scale_type_id;
		animator_scale_type_id = animator_scale_get_type_once ();
		g_once_init_leave (&animator_scale_type_id__volatile, animator_scale_type_id);
	}
	return animator_scale_type_id__volatile;
}

