/* UndoGroupsColor.c generated by valac 0.48.9, the Vala compiler
 * generated from UndoGroupsColor.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/

#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>

#define TYPE_UNDO_ITEM (undo_item_get_type ())
#define UNDO_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_UNDO_ITEM, UndoItem))
#define UNDO_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_UNDO_ITEM, UndoItemClass))
#define IS_UNDO_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_UNDO_ITEM))
#define IS_UNDO_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_UNDO_ITEM))
#define UNDO_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_UNDO_ITEM, UndoItemClass))

typedef struct _UndoItem UndoItem;
typedef struct _UndoItemClass UndoItemClass;
typedef struct _UndoItemPrivate UndoItemPrivate;

#define TYPE_DRAW_AREA (draw_area_get_type ())
#define DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DRAW_AREA, DrawArea))
#define DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DRAW_AREA, DrawAreaClass))
#define IS_DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DRAW_AREA))
#define IS_DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DRAW_AREA))
#define DRAW_AREA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DRAW_AREA, DrawAreaClass))

typedef struct _DrawArea DrawArea;
typedef struct _DrawAreaClass DrawAreaClass;

#define TYPE_UNDO_GROUPS_COLOR (undo_groups_color_get_type ())
#define UNDO_GROUPS_COLOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_UNDO_GROUPS_COLOR, UndoGroupsColor))
#define UNDO_GROUPS_COLOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_UNDO_GROUPS_COLOR, UndoGroupsColorClass))
#define IS_UNDO_GROUPS_COLOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_UNDO_GROUPS_COLOR))
#define IS_UNDO_GROUPS_COLOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_UNDO_GROUPS_COLOR))
#define UNDO_GROUPS_COLOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_UNDO_GROUPS_COLOR, UndoGroupsColorClass))

typedef struct _UndoGroupsColor UndoGroupsColor;
typedef struct _UndoGroupsColorClass UndoGroupsColorClass;
typedef struct _UndoGroupsColorPrivate UndoGroupsColorPrivate;

#define TYPE_NODE_GROUP (node_group_get_type ())
#define NODE_GROUP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NODE_GROUP, NodeGroup))
#define NODE_GROUP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NODE_GROUP, NodeGroupClass))
#define IS_NODE_GROUP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NODE_GROUP))
#define IS_NODE_GROUP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NODE_GROUP))
#define NODE_GROUP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NODE_GROUP, NodeGroupClass))

typedef struct _NodeGroup NodeGroup;
typedef struct _NodeGroupClass NodeGroupClass;
enum  {
	UNDO_GROUPS_COLOR_0_PROPERTY,
	UNDO_GROUPS_COLOR_NUM_PROPERTIES
};
static GParamSpec* undo_groups_color_properties[UNDO_GROUPS_COLOR_NUM_PROPERTIES];
#define _g_array_unref0(var) ((var == NULL) ? NULL : (var = (g_array_unref (var), NULL)))

struct _UndoItem {
	GObject parent_instance;
	UndoItemPrivate * priv;
};

struct _UndoItemClass {
	GObjectClass parent_class;
	void (*undo) (UndoItem* self, DrawArea* da);
	void (*redo) (UndoItem* self, DrawArea* da);
	gboolean (*matches) (UndoItem* self, UndoItem* item);
	void (*replace_with_item) (UndoItem* self, UndoItem* item);
	gchar* (*to_string) (UndoItem* self);
};

struct _UndoGroupsColor {
	UndoItem parent_instance;
	UndoGroupsColorPrivate * priv;
};

struct _UndoGroupsColorClass {
	UndoItemClass parent_class;
};

struct _UndoGroupsColorPrivate {
	GArray* _groups;
	GArray* _old_colors;
	GdkRGBA _new_color;
};

static gint UndoGroupsColor_private_offset;
static gpointer undo_groups_color_parent_class = NULL;

GType undo_item_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (UndoItem, g_object_unref)
GType draw_area_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DrawArea, g_object_unref)
GType undo_groups_color_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (UndoGroupsColor, g_object_unref)
gpointer node_group_ref (gpointer instance);
void node_group_unref (gpointer instance);
GParamSpec* param_spec_node_group (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
void value_set_node_group (GValue* value,
                           gpointer v_object);
void value_take_node_group (GValue* value,
                            gpointer v_object);
gpointer value_get_node_group (const GValue* value);
GType node_group_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NodeGroup, node_group_unref)
void undo_item_undo (UndoItem* self,
                     DrawArea* da);
void undo_item_redo (UndoItem* self,
                     DrawArea* da);
UndoGroupsColor* undo_groups_color_new (GArray* groups,
                                        GdkRGBA* new_color);
UndoGroupsColor* undo_groups_color_construct (GType object_type,
                                              GArray* groups,
                                              GdkRGBA* new_color);
UndoItem* undo_item_new (const gchar* name);
UndoItem* undo_item_construct (GType object_type,
                               const gchar* name);
static void _node_group_unref0_ (gpointer var);
static void _vala_NodeGroup_free_function_content_of (gpointer data);
static void _vala_GdkRGBA_free (GdkRGBA* self);
static void __vala_GdkRGBA_free0_ (gpointer var);
static void _vala_GdkRGBA_free_function_content_of (gpointer data);
void node_group_get_color (NodeGroup* self,
                           GdkRGBA * result);
static GdkRGBA* _vala_GdkRGBA_copy (GdkRGBA* self);
static void undo_groups_color_real_undo (UndoItem* base,
                                  DrawArea* da);
void node_group_set_color (NodeGroup* self,
                           GdkRGBA * value);
static void undo_groups_color_real_redo (UndoItem* base,
                                  DrawArea* da);
static void undo_groups_color_finalize (GObject * obj);
static GType undo_groups_color_get_type_once (void);

static inline gpointer
undo_groups_color_get_instance_private (UndoGroupsColor* self)
{
	return G_STRUCT_MEMBER_P (self, UndoGroupsColor_private_offset);
}

static void
_node_group_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (node_group_unref (var), NULL));
}

static void
_vala_NodeGroup_free_function_content_of (gpointer data)
{
	NodeGroup* self;
	self = *((NodeGroup**) data);
	_node_group_unref0_ (self);
}

static void
_vala_GdkRGBA_free (GdkRGBA* self)
{
	g_boxed_free (gdk_rgba_get_type (), self);
}

static void
__vala_GdkRGBA_free0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (_vala_GdkRGBA_free (var), NULL));
}

static void
_vala_GdkRGBA_free_function_content_of (gpointer data)
{
	GdkRGBA* self;
	self = *((GdkRGBA**) data);
	__vala_GdkRGBA_free0_ (self);
}

static gpointer
_node_group_ref0 (gpointer self)
{
	return self ? node_group_ref (self) : NULL;
}

static GdkRGBA*
_vala_GdkRGBA_copy (GdkRGBA* self)
{
	return g_boxed_copy (gdk_rgba_get_type (), self);
}

static gpointer
__vala_GdkRGBA_copy0 (gpointer self)
{
	return self ? _vala_GdkRGBA_copy (self) : NULL;
}

UndoGroupsColor*
undo_groups_color_construct (GType object_type,
                             GArray* groups,
                             GdkRGBA* new_color)
{
	UndoGroupsColor * self = NULL;
	GArray* _tmp0_;
	GArray* _tmp1_;
	GdkRGBA _tmp2_;
	g_return_val_if_fail (groups != NULL, NULL);
	g_return_val_if_fail (new_color != NULL, NULL);
	self = (UndoGroupsColor*) undo_item_construct (object_type, _ ("group color change"));
	_tmp0_ = g_array_new (TRUE, TRUE, sizeof (NodeGroup*));
	g_array_set_clear_func (_tmp0_, (GDestroyNotify) _vala_NodeGroup_free_function_content_of);
	_g_array_unref0 (self->priv->_groups);
	self->priv->_groups = _tmp0_;
	_tmp1_ = g_array_new (TRUE, TRUE, sizeof (GdkRGBA*));
	g_array_set_clear_func (_tmp1_, (GDestroyNotify) _vala_GdkRGBA_free_function_content_of);
	_g_array_unref0 (self->priv->_old_colors);
	self->priv->_old_colors = _tmp1_;
	_tmp2_ = *new_color;
	self->priv->_new_color = _tmp2_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				GArray* _tmp5_;
				NodeGroup* _tmp6_;
				NodeGroup* _tmp7_;
				GArray* _tmp8_;
				NodeGroup* _tmp9_;
				GdkRGBA _tmp10_ = {0};
				GdkRGBA _tmp11_;
				GdkRGBA* _tmp12_;
				if (!_tmp3_) {
					gint _tmp4_;
					_tmp4_ = i;
					i = _tmp4_ + 1;
				}
				_tmp3_ = FALSE;
				if (!(((guint) i) < groups->len)) {
					break;
				}
				_tmp5_ = self->priv->_groups;
				_tmp6_ = g_array_index (groups, NodeGroup*, (guint) i);
				_tmp7_ = _node_group_ref0 (_tmp6_);
				g_array_append_val (_tmp5_, _tmp7_);
				_tmp8_ = self->priv->_old_colors;
				_tmp9_ = g_array_index (groups, NodeGroup*, (guint) i);
				node_group_get_color (_tmp9_, &_tmp10_);
				_tmp11_ = _tmp10_;
				_tmp12_ = __vala_GdkRGBA_copy0 (&_tmp11_);
				g_array_append_val (_tmp8_, _tmp12_);
			}
		}
	}
	return self;
}

UndoGroupsColor*
undo_groups_color_new (GArray* groups,
                       GdkRGBA* new_color)
{
	return undo_groups_color_construct (TYPE_UNDO_GROUPS_COLOR, groups, new_color);
}

static void
undo_groups_color_real_undo (UndoItem* base,
                             DrawArea* da)
{
	UndoGroupsColor * self;
	self = (UndoGroupsColor*) base;
	g_return_if_fail (da != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				GArray* _tmp2_;
				GArray* _tmp3_;
				NodeGroup* _tmp4_;
				GArray* _tmp5_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = self->priv->_groups;
				if (!(((guint) i) < _tmp2_->len)) {
					break;
				}
				_tmp3_ = self->priv->_groups;
				_tmp4_ = g_array_index (_tmp3_, NodeGroup*, (guint) i);
				_tmp5_ = self->priv->_old_colors;
				node_group_set_color (_tmp4_, g_array_index (_tmp5_, GdkRGBA*, (guint) i));
			}
		}
	}
	gtk_widget_queue_draw ((GtkWidget*) da);
	g_signal_emit_by_name (da, "changed");
}

static void
undo_groups_color_real_redo (UndoItem* base,
                             DrawArea* da)
{
	UndoGroupsColor * self;
	self = (UndoGroupsColor*) base;
	g_return_if_fail (da != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				GArray* _tmp2_;
				GArray* _tmp3_;
				NodeGroup* _tmp4_;
				GdkRGBA _tmp5_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = self->priv->_groups;
				if (!(((guint) i) < _tmp2_->len)) {
					break;
				}
				_tmp3_ = self->priv->_groups;
				_tmp4_ = g_array_index (_tmp3_, NodeGroup*, (guint) i);
				_tmp5_ = self->priv->_new_color;
				node_group_set_color (_tmp4_, &_tmp5_);
			}
		}
	}
	gtk_widget_queue_draw ((GtkWidget*) da);
	g_signal_emit_by_name (da, "changed");
}

static void
undo_groups_color_class_init (UndoGroupsColorClass * klass,
                              gpointer klass_data)
{
	undo_groups_color_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &UndoGroupsColor_private_offset);
	((UndoItemClass *) klass)->undo = (void (*) (UndoItem*, DrawArea*)) undo_groups_color_real_undo;
	((UndoItemClass *) klass)->redo = (void (*) (UndoItem*, DrawArea*)) undo_groups_color_real_redo;
	G_OBJECT_CLASS (klass)->finalize = undo_groups_color_finalize;
}

static void
undo_groups_color_instance_init (UndoGroupsColor * self,
                                 gpointer klass)
{
	self->priv = undo_groups_color_get_instance_private (self);
}

static void
undo_groups_color_finalize (GObject * obj)
{
	UndoGroupsColor * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_UNDO_GROUPS_COLOR, UndoGroupsColor);
	_g_array_unref0 (self->priv->_groups);
	_g_array_unref0 (self->priv->_old_colors);
	G_OBJECT_CLASS (undo_groups_color_parent_class)->finalize (obj);
}

static GType
undo_groups_color_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (UndoGroupsColorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) undo_groups_color_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UndoGroupsColor), 0, (GInstanceInitFunc) undo_groups_color_instance_init, NULL };
	GType undo_groups_color_type_id;
	undo_groups_color_type_id = g_type_register_static (TYPE_UNDO_ITEM, "UndoGroupsColor", &g_define_type_info, 0);
	UndoGroupsColor_private_offset = g_type_add_instance_private (undo_groups_color_type_id, sizeof (UndoGroupsColorPrivate));
	return undo_groups_color_type_id;
}

GType
undo_groups_color_get_type (void)
{
	static volatile gsize undo_groups_color_type_id__volatile = 0;
	if (g_once_init_enter (&undo_groups_color_type_id__volatile)) {
		GType undo_groups_color_type_id;
		undo_groups_color_type_id = undo_groups_color_get_type_once ();
		g_once_init_leave (&undo_groups_color_type_id__volatile, undo_groups_color_type_id);
	}
	return undo_groups_color_type_id__volatile;
}

